
var consoleService = {
   console : Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),
   debug: function(msg) {
      if (this.debugEnabled) {
         this.console.logStringMessage(msg);
      }
   },
   log: function(msg) {
      this.console.logStringMessage(msg);
   }
}


var theInstance = null;

var Module = {


    registerSelf: function (compMgr, fileSpec, location, type) {
        consoleService.debug("*** Registering DAISYService JS components\n");
        compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        compMgr.registerFactoryLocation(this.myCID,
                                        "DAISYService Component",
                                        this.myProgID,
                                        fileSpec,
                                        location,
                                        type);
    },

    getClassObject : function (compMgr, cid, iid) {
       consoleService.debug("Getting class for "+cid);

       if (cid.equals(this.myCID)) {
          return this.myFactory;
       }
       if (!iid.equals(Components.interfaces.nsIFactory)) {
          throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
       }
       throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    myCID: Components.ID("{4655c7a3-5675-4ce7-beb4-8dbcb00e7971}"),
    myProgID: "@benetech.org/daisy;1",

    myFactory: {
        getService: function(outer,iid) {
           consoleService.debug("CI: " + iid + "\n");
           if (outer != null) {
              throw Components.results.NS_ERROR_NO_AGGREGATION;
           }
           if (!theInstance) {
              theInstance = _newInstance();
           }
           return theInstance.QueryInterface(iid);
        },
        createInstance: function (outer, iid) {
            dump("CI: " + iid + "\n");
            if (outer != null) {
               throw Components.results.NS_ERROR_NO_AGGREGATION;
            }
            return _newInstance().QueryInterface(iid);
        }
    },

    canUnload: function(compMgr) {
        consoleService.debug("****** Unloading: DAISYService JS component! ****** \n");
        return true;
    }
}; // END Module

function _newInstance() {
   consoleService.debug("Creating singleton for DAISYService");
   DAISYService.preferences = new DAISYPreferences();
   return new DAISYService();
}

function NSGetModule(compMgr, fileSpec) { return Module; }


function DAISYPreferences() {
   this.preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("daisy.");
   this._debug = this.preferencesService.prefHasUserValue("debug") ? this._getBoolean("debug") : false;
   this._allowQuirks = this.preferencesService.prefHasUserValue("allowQuirks") ? this._getBoolean("allowQuirks") : true;
   this._sound = this.preferencesService.prefHasUserValue("sound") ? this._getBoolean("sound") : true;
   this._showImages = this.preferencesService.prefHasUserValue("showImages") ? this._getBoolean("showImages") : true;
   this._focusFollow = this.preferencesService.prefHasUserValue("focusFollow") ? this._getBoolean("focusFollow") : true;
   this._highlight = this.preferencesService.prefHasUserValue("highlight") ? this._getBoolean("highlight") : true;
   this._readContent = this.preferencesService.prefHasUserValue("readContent") ? this._getBoolean("readContent") : true;
   this._readUI = this.preferencesService.prefHasUserValue("readUI") ? this._getBoolean("readUI") : false;
   this._forceReadContent = this.preferencesService.prefHasUserValue("forceReadContent") ? this._getBoolean("forceReadContent") : false;
   this._navigateByStructure = this.preferencesService.prefHasUserValue("navigateByStructure") ? this._getBoolean("navigateByStructure") : true;
   this._sidebarPause = this.preferencesService.prefHasUserValue("sidebarPause") ? this._getBoolean("sidebarPause") : false;
   this._readNotesInline = this.preferencesService.prefHasUserValue("readNotesInline") ? this._getBoolean("readNotesInline") : false;
   this._cueSidebarOpen = this.preferencesService.prefHasUserValue("cueSidebarOpen") ? this._getBoolean("cueSidebarOpen") : false;
   this._textDuration = this.preferencesService.prefHasUserValue("textDuration") ? this._getInteger("textDuration") : 2000;
   this._playbackPause = this.preferencesService.prefHasUserValue("playbackPause") ? this._getInteger("playbackPause") : 500;
   this._speechRate = this.preferencesService.prefHasUserValue("speechRate") ? this._getInteger("speechRate") : null;
}

DAISYPreferences.prototype.__defineGetter__("debug", function() {
   return this._debug;
});
DAISYPreferences.prototype.__defineSetter__("debug", function(v) {
   this._debug = v;
   this._setBoolean("debug",v);
});

DAISYPreferences.prototype.__defineGetter__("allowQuirks", function() {
   return this._allowQuirks;
});
DAISYPreferences.prototype.__defineSetter__("allowQuirks", function(v) {
   this._allowQuirks = v;
   this._setBoolean("allowQuirks",v);
});

DAISYPreferences.prototype.__defineGetter__("sound", function() {
   return this._sound;
});
DAISYPreferences.prototype.__defineSetter__("sound", function(v) {
   this._sound = v;
   this._setBoolean("sound",v);
});

DAISYPreferences.prototype.__defineGetter__("showImages", function() {
   return this._showImages;
});
DAISYPreferences.prototype.__defineSetter__("showImages", function(v) {
   this._showImages = v;
   this._setBoolean("showImages",v);
});

DAISYPreferences.prototype.__defineGetter__("focusFollow", function() {
   return this._focusFollow;
});
DAISYPreferences.prototype.__defineSetter__("focusFollow", function(v) {
   this._focusFollow = v;
   this._setBoolean("focusFollow",v);
});

DAISYPreferences.prototype.__defineGetter__("highlight", function() {
   return this._highlight;
});
DAISYPreferences.prototype.__defineSetter__("highlight", function(v) {
   this._highlight = v;
   this._setBoolean("highlight",v);
});

DAISYPreferences.prototype.__defineGetter__("readUI", function() {
   return this._readUI;
});
DAISYPreferences.prototype.__defineSetter__("readUI", function(v) {
   this._readUI = v;
   this._setBoolean("readUI",v);
});

DAISYPreferences.prototype.__defineGetter__("readContent", function() {
   return this._readContent;
});
DAISYPreferences.prototype.__defineSetter__("readContent", function(v) {
   this._readContent = v;
   this._setBoolean("readContent",v);
});

DAISYPreferences.prototype.__defineGetter__("forceReadContent", function() {
   return this._forceReadContent;
});
DAISYPreferences.prototype.__defineSetter__("forceReadContent", function(v) {
   this._forceReadContent = v;
   this._setBoolean("forceReadContent",v);
});

DAISYPreferences.prototype.__defineGetter__("navigateByStructure", function() {
   return this._navigateByStructure;
});
DAISYPreferences.prototype.__defineSetter__("navigateByStructure", function(v) {
   this._navigateByStructure = v;
   this._setBoolean("navigateByStructure",v);
});

DAISYPreferences.prototype.__defineGetter__("sidebarPause", function() {
   return this._sidebarPause;
});
DAISYPreferences.prototype.__defineSetter__("sidebarPause", function(v) {
   this._sidebarPause = v;
   this._setBoolean("sidebarPause",v);
});

DAISYPreferences.prototype.__defineGetter__("readNotesInline", function() {
   return this._readNotesInline;
});
DAISYPreferences.prototype.__defineSetter__("readNotesInline", function(v) {
   this._readNotesInline = v;
   this._setBoolean("readNotesInline",v);
});

DAISYPreferences.prototype.__defineGetter__("cueSidebarOpen", function() {
   return this._cueSidebarOpen;
});
DAISYPreferences.prototype.__defineSetter__("cueSidebarOpen", function(v) {
   this._cueSidebarOpen = v;
   this._setBoolean("cueSidebarOpen",v);
});

DAISYPreferences.prototype.__defineGetter__("textDuration", function() {
   return this._textDuration;
});
DAISYPreferences.prototype.__defineSetter__("textDuration", function(v) {
   this._textDuration = v;
   this._setInteger("textDuration",v);
});

DAISYPreferences.prototype.__defineGetter__("playbackPause", function() {
   return this._playbackPause;
});
DAISYPreferences.prototype.__defineSetter__("playbackPause", function(v) {
   this._playbackPause = v;
   this._setInteger("playbackPause",v);
});

DAISYPreferences.prototype.__defineGetter__("speechRate", function() {
   return this._speechRate;
});
DAISYPreferences.prototype.__defineSetter__("speechRate", function(v) {
   this._speechRate = v;
   if (v) {
      this._setInteger("speechRate",v);
   } else {
      this.preferencesService.clearUserPref("speechRate");
   }
});

DAISYPreferences.prototype._getBoolean = function(name) {
   try {
      return this.preferencesService.getBoolPref(name);
   } catch (ex) {
      return false;
   }
}

DAISYPreferences.prototype._setBoolean = function(name,value) {
   return this.preferencesService.setBoolPref(name,value);
}

DAISYPreferences.prototype._getString = function(name) {
   try {
      return this.preferencesService.getCharPref(name);
   } catch (ex) {
      return null;
   }
}

DAISYPreferences.prototype._setString = function(name,value) {
   return this.preferencesService.setCharPref(name,value);
}

DAISYPreferences.prototype._getInteger = function(name) {
   try {
      return this.preferencesService.getIntPref(name);
   } catch (ex) {
      return null;
   }
}

DAISYPreferences.prototype._setInteger = function(name,value) {
   return this.preferencesService.setIntPref(name,value);
}

function DAISYService() {
   this.wrappedJSObject = this;
   this._window = null;
   this.locks = {};
   this.libraries = {};
   this.books = {};
   this.flashUpdated = false;
   this.prefObservers = [];
   this._defaults = {};
   this._active = false;
   this._defaults["WINNT.unzip.command"] = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager).getInstallLocation(DAISYService.extID).getItemFile(DAISYService.extID,"unzip.exe").path;
   this._defaults["default.unzip.command"] = "/usr/bin/unzip";
   var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("daisy.zip.");
   if (preferencesService) {
      try {
         this.unzipCommand = preferencesService.getCharPref("command");
      } catch (ex) {
         // no preference
      }
   }
   if (!this.unzipCommand) {
      this.unzipCommand = this.defaults[DAISYService.OS+".unzip.command"];
      if (!this.unzipCommand) {
         this.unzipCommand = this.defaults["default.unzip.command"];
      }
      DAISYService.console.debug("unzip command defaults to: "+this.unzipCommand);
   }
   this._renderer = this.createRenderer();
   this._renderer.setSMILTransform("chrome://daisy/content/daisy/dtbook2smil.xsl");
   this._renderer.setXHTMLTransform("chrome://daisy/content/daisy/dtbook2xhtml.xsl");
   try {
      this.ttsMediator = Components.classes["@benetech.org/tts-mediator-service;1"].getService(Components.interfaces.nsITTSMediatorService);
      this._tts = this.ttsMediator.findEngine(null);
      if (!this._tts) {
         DAISYService.console.log("A TTS factory is not available.");
      } else {
         if (this.speechRate) {
            this._tts.rate = this.speechRate;
         }
         DAISYService.console.log("TTS rate: "+this._tts.rate+", ("+this._tts.minimumRate+", "+this._tts.normalRate+", "+this._tts.maximumRate+", "+this._tts.rateUnit+")");
      }
   } catch (ex) {
      DAISYService.console.log("Error initializing TTS: "+ex);
   }

   var domPreferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("dom.");
   if (!domPreferencesService.prefHasUserValue("max_chrome_script_run_time")) {
      domPreferencesService.setIntPref("max_chrome_script_run_time",40);
   };
   if (!domPreferencesService.prefHasUserValue("max_script_run_time")) {
      domPreferencesService.setIntPref("max_script_run_time",40);
   };

   this.productInfo = new DAISYProductInfo();

}

DAISYService.prototype.__defineGetter__("tts",function() {
   return this._tts;
});


DAISYService.prototype.__defineGetter__("renderer",function() {
   return this._renderer;
});

DAISYService.prototype.__defineGetter__("database",function() {
   if (!this._database) {
      var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
      var dbFile = dirService.get("ProfD", Components.interfaces.nsILocalFile);
      dbFile.append("daisy.sqlite");
      this._database = new DAISYDB();
      this._database.open(dbFile);
   }
   return this._database;
});

DAISYService.prototype.updateFlashSecurity = function() {
   var extManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
   // the path may use forward slash ("/") as the delimiter
   // returns nsIFile for the extension's install.rdf
   var id = "{6be5ef88-4289-44d1-81f2-097313ed640b}";
   var flashFiles = [];
   flashFiles.push({ path: "chrome://daisy/content/sidebar.xul"});
   flashFiles.push({ path: "chrome://daisy/content/sound.xul"});
   flashFiles.push({ path: "chrome://daisy/content/sound.xhtml"});
   flashFiles.push(extManager.getInstallLocation(id).getItemFile(id,"content/galley.xhtml"));
   flashFiles.push(extManager.getInstallLocation(id).getItemFile(id,"content/rendered.xhtml"));
   flashFiles.push(extManager.getInstallLocation(id).getItemFile(id,"content/rendered-player.xhtml"));
   flashFiles.push(extManager.getInstallLocation(id).getItemFile(id,"content/sound.xhtml"));
   flashFiles.push(extManager.getInstallLocation(id).getItemFile(id,"content/soundmanager2/swf/soundmanager2.swf"));
   flashFiles.push(extManager.getInstallLocation(id).getItemFile(id,"content/soundmanager2/swf/soundmanager2_flash9.swf"));

   var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
   var flashfile = null;
   if (DAISYService.OS=="WINNT") {
      var desktop = dirService.get("Desk", Components.interfaces.nsILocalFile);
      flashfile = desktop.parent;
      flashfile.append("Application Data");
      flashfile.append("Macromedia");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
      flashfile.append("Flash Player");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
      flashfile.append("#Security");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
      flashfile.append("FlashPlayerTrust");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }

   } else if (DAISYService.OS=="Darwin") {
      flashfile = dirService.get("Home", Components.interfaces.nsILocalFile);
      flashfile.append("Library");
      flashfile.append("Preferences");
      flashfile.append("Macromedia");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
      flashfile.append("Flash Player");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
      flashfile.append("#Security");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
      flashfile.append("FlashPlayerTrust");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
   } else if (DAISYService.OS=="Linux" || DAISYService.OS=="SunOS") {
      // /home/{user}/.macromedia/Flash_Player/#Security/FlashPlayerTrust
      flashfile = dirService.get("Home", Components.interfaces.nsILocalFile);
      flashfile.append(".macromedia");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
      flashfile.append("Flash_Player");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
      flashfile.append("#Security");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
      flashfile.append("FlashPlayerTrust");
      if (!flashfile.exists()) {
         flashfile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
   } else {
      DAISYService.console.log("Unable to check flash security for OS "+DAISYService.OS);
      return;
   }
   flashfile.append("daisy.cfg");
   if (flashfile.exists()) {
      if (!this.flashUpdated) {
         flashfile.remove(false);
      } else {
         return;
      }
   }
   DAISYService.console.log("Creating flash security configuration: "+flashfile.path);
   var out = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

   var eol = DAISYService.OS=="WINNT" ? "\r\n" : "\n";
   out.init(flashfile, 0x02 | 0x08 | 0x20, 0666, 0);

   for (var i=0; i<flashFiles.length; i++) {
      out.write(flashFiles[i].path,flashFiles[i].path.length); out.write(eol,eol.length);
   }
   /*
   for (var uri in this.books) {
      var file = DAISYService.getFileFromURI(uri);
      if (file) {
         out.write(file.path,file.path.length); out.write(eol,eol.length);
      }
   }
   */
   out.close();
   this.flashUpdated = true;
}

DAISYService.preferences = null;

DAISYService.prototype.__defineGetter__("defaults", function() {
   if (!this._defaults) {
   }
   return this._defaults;
});


DAISYService.console = {
   service: Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),
   log: function(message) {
      this.service.logStringMessage(message);
   },
   debug: function(message) {
      if (DAISYService.preferences && DAISYService.preferences.debug) {
         this.service.logStringMessage(message);
      }
   }
}

DAISYService.extID = "{6be5ef88-4289-44d1-81f2-097313ed640b}";
DAISYService.OS = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;

DAISYService.ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
DAISYService.fileURL = function(file) {
   return DAISYService.ios.newFileURI(file);
}

DAISYService.getFileFromURI = function(suri) {
   var uri = DAISYService.ios.newURI(suri,"UTF-8",null);
   if (uri.scheme=="file") {
      uri = uri.QueryInterface(Components.interfaces.nsIFileURL);
      return uri.file;
   }
   return null;
}

DAISYService.prototype.addPreferenceObserver = function(listener) {
   this.prefObservers.push(listener);
}

DAISYService.prototype.removePreferenceObserver = function(listener) {
   for (var i=0; i<this.prefObservers.length; i++) {
      if (this.prefObservers[i]==listener) {
         this.prefObservers.splice(i,1);
         return;
      }
   }
}

DAISYService.prototype.notifyPreferenceChange = function(name) {
   for (var i=0; i<this.prefObservers.length; i++) {
      this.prefObservers[i].onChange(name);
   }
}

DAISYService.prototype.__defineGetter__("active", function() {
   return this._active;
});
DAISYService.prototype.__defineSetter__("active", function(v) {
   this._active = v ? true : false;
});

DAISYService.prototype.__defineGetter__("debug", function() {
   return DAISYService.preferences.debug;
});
DAISYService.prototype.__defineSetter__("debug", function(v) {
   DAISYService.preferences.debug = v ? true : false;
   this.smil.debug = DAISYService.preferences.debug;
   this.notifyPreferenceChange("debug");
});

DAISYService.prototype.__defineGetter__("allowQuirks", function() {
   return DAISYService.preferences.allowQuirks;
});
DAISYService.prototype.__defineSetter__("allowQuirks", function(v) {
   DAISYService.preferences.allowQuirks = v ? true : false;
   DAISYNavigationControl.allowQuirks = DAISYService.preferences.allowQuirks;
   this.smil.allowQuirks = DAISYService.preferences.allowQuirks;
   this.notifyPreferenceChange("allowQuirks");
});

DAISYService.prototype.__defineGetter__("sound", function() {
   return DAISYService.preferences.sound;
});
DAISYService.prototype.__defineSetter__("sound", function(v) {
   DAISYService.preferences.sound = v ? true : false;
   this.notifyPreferenceChange("sound");
});

DAISYService.prototype.__defineGetter__("showImages", function() {
   return DAISYService.preferences.showImages;
});
DAISYService.prototype.__defineSetter__("showImages", function(v) {
   DAISYService.preferences.showImages = v ? true : false;
   this.notifyPreferenceChange("showImages");
});

DAISYService.prototype.__defineGetter__("focusFollow", function() {
   return DAISYService.preferences.focusFollow;
});
DAISYService.prototype.__defineSetter__("focusFollow", function(v) {
   DAISYService.preferences.focusFollow = v ? true : false;
   this.notifyPreferenceChange("focusFollow");
});

DAISYService.prototype.__defineGetter__("highlight", function() {
   return DAISYService.preferences.highlight;
});
DAISYService.prototype.__defineSetter__("highlight", function(v) {
   DAISYService.preferences.highlight = v ? true : false;
   this.notifyPreferenceChange("highlight");
});

DAISYService.prototype.__defineGetter__("readUI", function() {
   return DAISYService.preferences.readUI;
});
DAISYService.prototype.__defineSetter__("readUI", function(v) {
   DAISYService.preferences.readUI = v ? true : false;
   this.notifyPreferenceChange("readUI");
});

DAISYService.prototype.__defineGetter__("readContent", function() {
   return DAISYService.preferences.readContent;
});
DAISYService.prototype.__defineSetter__("readContent", function(v) {
   DAISYService.preferences.readContent = v ? true : false;
   this.notifyPreferenceChange("readContent");
});

DAISYService.prototype.__defineGetter__("forceReadContent", function() {
   return DAISYService.preferences.forceReadContent;
});
DAISYService.prototype.__defineSetter__("forceReadContent", function(v) {
   DAISYService.preferences.forceReadContent = v ? true : false;
   this.notifyPreferenceChange("forceReadContent");
});

DAISYService.prototype.__defineGetter__("navigateByStructure", function() {
   return DAISYService.preferences.navigateByStructure;
});
DAISYService.prototype.__defineSetter__("navigateByStructure", function(v) {
   DAISYService.preferences.navigateByStructure = v ? true : false;
   this.notifyPreferenceChange("navigateByStructure");
});

DAISYService.prototype.__defineGetter__("sidebarPause", function() {
   return DAISYService.preferences.sidebarPause;
});
DAISYService.prototype.__defineSetter__("sidebarPause", function(v) {
   DAISYService.preferences.sidebarPause = v ? true : false;
   this.notifyPreferenceChange("sidebarPause");
});

DAISYService.prototype.__defineGetter__("readNotesInline", function() {
   return DAISYService.preferences.readNotesInline;
});
DAISYService.prototype.__defineSetter__("readNotesInline", function(v) {
   DAISYService.preferences.readNotesInline = v ? true : false;
   this.notifyPreferenceChange("readNotesInline");
});

DAISYService.prototype.__defineGetter__("cueSidebarOpen", function() {
   return DAISYService.preferences.cueSidebarOpen;
});
DAISYService.prototype.__defineSetter__("cueSidebarOpen", function(v) {
   DAISYService.preferences.cueSidebarOpen = v ? true : false;
   this.notifyPreferenceChange("cueSidebarOpen");
});


DAISYService.prototype.__defineGetter__("textDuration", function() {
   return DAISYService.preferences.textDuration;
});
DAISYService.prototype.__defineSetter__("textDuration", function(v) {
   DAISYService.preferences.textDuration = v;
   this.smil.textOnlyPause = v;
   this.notifyPreferenceChange("textDuration");
});

DAISYService.prototype.__defineGetter__("playbackPause", function() {
   return DAISYService.preferences.playbackPause;
});
DAISYService.prototype.__defineSetter__("playbackPause", function(v) {
   DAISYService.preferences.playbackPause = v;
   this.notifyPreferenceChange("playbackPause");
});

DAISYService.prototype.__defineGetter__("speechRate", function() {
   return DAISYService.preferences.speechRate;
});
DAISYService.prototype.__defineSetter__("speechRate", function(v) {
   DAISYService.preferences.speechRate = v;
   if (v) {
      // set the rate value
      this._tts.rate = v;
   } else {
      // reset to system defaults by finding a new engine
      this._tts.rate = this._tts.normalRate;
   }
   this.notifyPreferenceChange("speechRate");
});


DAISYService.prototype.__defineGetter__("smil", function() {
   if (!DAISYService.smilEngine) {
      try {
         var theClass = Components.classes["@benetech.org/daisy-smil-engine;1"];
         if (theClass) {
            var theComponent = theClass.getService(Components.interfaces.nsISupports);
            DAISYService.smilEngine = theComponent.wrappedJSObject;
            DAISYService.smilEngine.debug = DAISYService.preferences.debug;
            DAISYService.smilEngine.textOnlyPause = DAISYService.preferences.textDuration;
            DAISYService.smilEngine.allowQuirks = DAISYService.preferences.allowQuirks;
         } else {
            DAISYService.console.log("Cannot find SMIL engine class.");
         }
      } catch (ex) {
         DAISYService.console.log("Cannot load SMIL engine: "+ex);
      }
   }
   return DAISYService.smilEngine;
});

DAISYService.prototype.__defineGetter__("OS", function() {
   return DAISYService.OS;
});


DAISYService.prototype.__defineGetter__("window", function() {
   if (!this._window || this._window.closed) {
      var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                   .getService(Components.interfaces.nsIWindowWatcher);
      this._window = ww.openWindow(
         null,
         'chrome://daisy/content/player.xul',
         'daisy-player',
         'centerscreen,chrome,resizable',
         null
      );
   }
   return this._window;
});

DAISYService.prototype.unload = function() {
   if (this._window) {
      this._window.close();
      this._window = null;
   }
   this.libraries = {};
   this.books = {};
}

DAISYService.prototype.getBook = function(uri) {
   DAISYService.console.debug("Get book "+uri);
   return this.books[uri];
}

DAISYService.prototype.newBook = function(uri) {
   var current = this;
   var book = new DAISYBook();
   book.init();
   book.onDestroy = function() {
      current.removeBook(uri);
   }
   if (uri) {
      this.mapBook(uri,book);
   }
   return book;
}

DAISYService.prototype.mapBook = function(uri,book) {
   DAISYService.console.debug("Mapping "+uri+" to book");
   this.books[uri] = book;
}

DAISYService.prototype.removeBook = function(uri) {
   DAISYService.console.debug("Removing book "+uri);
   delete this.books[uri];
}

DAISYService.prototype.createRenderer = function() {
   return new DAISYRenderer(this);
}


DAISYService.prototype.getLibrary = function(dir) {
   var lib = this.libraries[dir];
   if (!lib) {
      lib = new DAISYLibrary(this,dir);
      if (!lib.dir.exists()) {
         DAISYService.console.log("Library directory "+lib.dir.path+" does not exist.");
         return null;
      }
      lib.load();
      this.libraries[dir] = lib;
   }
   return lib;
}

DAISYService.prototype.findPackagingInDirectory = function(dir) {
   var bookDirEntries = dir.directoryEntries;
   var opfTest = /\.opf$/;
   while (bookDirEntries.hasMoreElements()) {
      var bookFile = bookDirEntries.getNext().QueryInterface(Components.interfaces.nsIFile);
      if (bookFile.leafName.match(opfTest)) {
         return bookFile;
      }
   }
   return null;
}

DAISYService.prototype.getBookDirectory = function(book) {
   for (var id in book.uris) {
      var uri = DAISYService.ios.newURI(book.uris[id],"UTF-8",null);
      DAISYService.console.debug("Book URI for directory calculation: "+uri.spec);
      if (uri.scheme=="file") {
         uri = uri.QueryInterface(Components.interfaces.nsIFileURL);
         if (uri.path.match(".zip$")==".zip" || uri.path.match(".bks2$")==".bks2") {
            var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            file.initWithPath(uri.file.parent.path);
            var pos = uri.file.leafName.lastIndexOf(".zip");
            if (pos<0) {
               pos = uri.file.leafName.lastIndexOf(".bks2");
            }
            file.appendRelativePath(uri.file.leafName.substring(0,pos));
            DAISYService.console.debug("Book unzip dir: "+file.path);
            return file;
         } else {
            DAISYService.console.debug("Book parent dir: "+uri.file.parent.path);
            return uri.file.parent;
         }
      }
   }
   return null;
}

DAISYService.prototype.isExtracted = function(book) {
   var bookDir = this.getBookDirectory(book);
   if (bookDir && bookDir.exists()) {
      var item = book.manifest[book.spine[0]];
      if (item) {
         var smilFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
         smilFile.initWithPath(bookDir.path);
         smilFile.appendRelativePath(item.href);
         return smilFile.exists();
      }
   }
   return false;
}


DAISYService.prototype.extract = function(zipFile,targetDir,password) {

   DAISYService.console.log("Unpacking to "+targetDir.path);

   var file =  Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

   file.initWithPath(this.unzipCommand);

   if (!file.exists()) {
      return -1;
   }


   this.process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
   this.process.init(file);
   var argv = [ "-o", "-qq", ];
   if (password) {
      argv.push("-P");
      argv.push(password);
   }

   argv.push("-d");
   argv.push(targetDir.path);

   argv.push(zipFile.path);

   //alert(argv.join(" "));

   this.process.run(true, argv, argv.length);

   // we do this because the status returned on OS X is wrong
   var current = this;
   var count = 0;
   var waitFor = function() {
      if ((count>10 && current.process.exitValue==0) || current.process.exitValue>0) {
         if (current.onComplete) {
            current.onComplete(current.process.exitValue);
         }
      } else {
         count++;
         setTimeout(waitFor,100);
      }
   }
   waitFor();
}

DAISYService.prototype.readZipPackaging = function(zipFile) {
   DAISYService.console.debug("Loading opf from "+zipFile.path);
   var zipReader = Components.classes["@mozilla.org/libjar/zip-reader;1"].createInstance(Components.interfaces.nsIZipReader);
   zipReader.open(zipFile);
   var entryIterator = zipReader.findEntries(null);
   var opfPath = null;
   var extensionTest = /\.([^\.]+)$/;
   while (entryIterator.hasMore()) {
      var path = entryIterator.getNext()
      var ext = path.match(extensionTest);
      if (ext) {
         if (ext[1]=="opf") {
            opfPath = path;
         }
      }
   }
   var is = zipReader.getInputStream(opfPath);
   var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"].createInstance(Components.interfaces.nsIDOMParser);
   var doc = parser.parseFromStream(is,"UTF-8",is.available(),"text/xml");
   is.close();
   zipReader.close();
   var pos = zipFile.leafName.lastIndexOf(".zip");
   if (pos<0) {
      pos = zipFile.leafName.lastIndexOf(".bks2");
   }
   return {
      document: doc,
      baseURI: DAISYService.fileURL(zipFile.parent).spec+zipFile.leafName.substring(0,pos)+"/"+opfPath
   };
}

DAISYService.prototype.getLockFor = function(id) {
   var lock = this.locks[id];
   if (!lock) {
      lock = new Lock(id);
      this.locks[id] = lock;
   }
   return lock;
}

DAISYService.prototype.QueryInterface = function(iid) {
   DAISYService.console.debug("Querying: "+iid);
    /*
     *  This code specifies that the component supports 1 interfaces:
     *  nsISupports.
     */
    if (!iid.equals(Components.interfaces.nsISupports)) {
        throw Components.results.NS_ERROR_NO_INTERFACE;
    }
    return this;
};

function Lock(name) {
   this.name = name;
   this.owner = null;
}

Lock.prototype.acquire = function(options) {
   var current = this;
   var newOwner = null;
   if (options && options.exclusive || !this.owner) {
      newOwner = {
         lock: current,
         relinquish: function() {
            DAISYService.console.debug("Relinquishing lock "+current.name);
            current.owner = null;
            if (options.onRelinquish) {
               options.onRelinquish();
            }
         },
         release: function() {
            DAISYService.console.debug("Releasing lock "+current.name);
            current.owner = null;
            if (options.onRelease) {
               options.onRelease();
            }
         }
      }
   }
   if (options && options.exclusive) {
      if (this.owner) {
         this.owner.relinquish();
      }
   } else if (this.owner) {
      return null;
   }
   this.owner = newOwner;
   if (this.owner) {
      DAISYService.console.debug("Lock "+current.name+" acquired.");
   }
   return newOwner;
}



function DAISYDB() {
}

DAISYDB.prototype.open = function(file) {
   var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);
   if (file.exists()) {
      this.connection = storageService.openDatabase(file);
      switch (this.checkSchema()) {
         case -1:
            // there is no schema for some reason
            // so remove the db file
            this.close();
            file.remove(false);
            this.open(file);
            break;
         case 0:
            // upgrade the schema
            if (!this.upgrade()) {
               throw "Cannot upgrade DAISY database.";
            }
            break;
         case 1:
            break;
      }
   } else {
      this.connection = storageService.openDatabase(file);
      this.createSchema();
   }

}

DAISYDB.prototype.upgrade = function() {
   if (this.version=="1.0.0") {
      DAISYService.console.log("Upgrading database version "+this.version);
      var needsUpgrade = true;
      try {
         var statement = this.connection.createStatement("select position from recent_books limit 1");
         if (statement.executeStep()) {
            needsUpgrade = false;
         }
      } catch (ex) {
         DAISYService.console.log("The 'position' column needs to be added to the recent_books table.");
      }

      if (needsUpgrade) {
         DAISYService.console.log("Updating recent_books..");

         try {
            this.connection.executeSimpleSQL("alter table recent_books add column position TEXT");
         } catch (ex) {
            DAISYService.console.log("Cannot add 'position' column to 'recent_books', error: "+ex);
            return false;
         }
         /*
         // alter table does not seem to work
         DAISYService.console.log("Getting book history..");
         var history = [];
         var statement = this.connection.createStatement("select title,url,used from recent_books order by used desc");
         while (statement.executeStep()) {
            history.push({
               title: statement.getString(0),
               url: statement.getString(1),
               used: statement.getInt64(2),
            })
         }
         try {
            this.connection.executeSimpleSQL("drop table if exists recent_books");
         } catch (ex) {
            DAISYService.console.log("Cannot drop recent_books table in database version "+this.version+", error: "+ex);
            return false;
         }

         DAISYService.console.log("Restoring book history...");
         for (var i=0; i<history.length; i++) {
            this.bookViewed(history[i].title,history[i].url,null,history[i].used);
         }
         */
         DAISYService.console.log("Table recent_books updated.");
      }
      
      DAISYService.console.log("Updating database version to "+DAISYDB.SCHEMA_INFO);
      statement = this.connection.createStatement("delete from version");
      while (statement.executeStep()) { }
      statement = this.connection.createStatement("insert into version (info) values (?1)");
      statement.bindUTF8StringParameter(0,DAISYDB.SCHEMA_INFO);
      while (statement.executeStep()) { }
      this.version = DAISYDB.SCHEMA_INFO;
      return true;
   } else {
      DAISYService.console.log("No upgrade for database version "+this.version);
      // no upgrade available
      return false;
   }
}

DAISYDB.SCHEMA_INFO = "1.1.0";

DAISYDB.prototype.checkSchema = function() {
   if (!this.connection.tableExists("version")) {
      return -1;
   }
   var statement = this.connection.createStatement("select info from version");
   if (statement.executeStep()) {
      this.version = statement.getString(0);
      if (this.version==DAISYDB.SCHEMA_INFO) {
         return 1;
      }
   }
   return 0;

}

DAISYDB.prototype.createSchema = function() {
   if (!this.connection.tableExists("version")) {
      this.connection.createTable("version","info TEXT");
   }
   if (!this.connection.tableExists("recent_books")) {
      this.connection.createTable("recent_books","id INTEGER PRIMARY KEY AUTOINCREMENT,title TEXT, url TEXT, used TIMESTAMP, position TEXT");
   }
   if (!this.connection.tableExists("notes")) {
      this.connection.createTable("notes","id INTEGER PRIMARY KEY AUTOINCREMENT,url TEXT,updated TIMESTAMP,xpath TEXT,name TEXT,note TEXT");
   }

   var statement = this.connection.createStatement("insert into version (info) values (?1)");
   statement.bindUTF8StringParameter(0,DAISYDB.SCHEMA_INFO);
   while (statement.executeStep()) { }

}

DAISYDB.prototype.close = function() {
   this.connection.close();
}

DAISYDB.prototype.getBookHistory = function(limit) {
   var history = [];
   var statement = this.connection.createStatement("select title,url,position from recent_books order by used desc"+(limit ? " limit "+limit : ""));
   while (statement.executeStep()) {
      history.push({
         title: statement.getString(0),
         url: statement.getString(1),
         position: statement.getString(2)
      })
   }
   return history;
}

DAISYDB.prototype.bookViewed = function(title,url,position,used) {
   var hash = url.indexOf("#");
   if (hash>0) {
      if (!position) {
         position = url.substring(hash+1);
         var q = position.indexOf("?");
         if (q>=0) {
            position = position.substring(0,q);
         }
      }
      url = url.substring(0,hash);
   }
   this.removeBookHistory(url);
   if (title==null) {
      title = url;
   }
   var statement = this.connection.createStatement("insert into recent_books (title,url,position,used) values (?1,?2,?3,?4)");
   statement.bindUTF8StringParameter(0,title);
   statement.bindUTF8StringParameter(1,url);
   statement.bindUTF8StringParameter(2,position);
   statement.bindInt64Parameter(3,used ? used : (new Date()).getTime());
   while (statement.executeStep()) { }
}

DAISYDB.prototype.removeBookHistory = function(url) {
   var hash = url.indexOf("#");
   if (hash>0) {
      url = url.substring(0,hash);
   }
   var statement = this.connection.createStatement("delete from recent_books where url=?1");
   statement.bindUTF8StringParameter(0,url);
   while (statement.executeStep()) { }
}

DAISYDB.prototype.addNote = function(url,xpath,name,note) {
   var hash = url.indexOf("#");
   if (hash>0) {
      url = url.substring(0,hash);
   }
   var updated = (new Date()).getTime();
   var statement = this.connection.createStatement("insert into notes (url,updated,xpath,name,note) values (?1,?2,?3,?4,?5)");
   statement.bindUTF8StringParameter(0,url);
   statement.bindInt64Parameter(1,updated);
   statement.bindUTF8StringParameter(2,xpath);
   statement.bindUTF8StringParameter(3,name);
   statement.bindUTF8StringParameter(4,note);
   while (statement.executeStep()) { }

   return {
      id: this.connection.lastInsertRowID,
      url: url,
      updated: updated,
      xpath: xpath,
      name: name,
      note: note
   };
}

DAISYDB.prototype.updateNote = function(a,b,c) {
   var id = a.id ? a.id : a;
   var name = a.id ? a.name : b;
   var note = a.id ? a.note : c;
   var updated = (new Date()).getTime();
   var statement = this.connection.createStatement("update notes set name=?1,note=?2,updated=?3 where id=?4");
   statement.bindUTF8StringParameter(0,name);
   statement.bindUTF8StringParameter(1,note);
   statement.bindInt64Parameter(2,updated);
   statement.bindInt32Parameter(3,id);
   statement.executeStep();
   if (a.id) {
      a.updated = updated;
   }
}

DAISYDB.prototype.removeNotes = function(url) {
   var hash = url.indexOf("#");
   if (hash>0) {
      url = url.substring(0,hash);
   }
   var statement = this.connection.createStatement("delete from notes where url=?1");
   statement.bindUTF8StringParameter(0,url);
   while (statement.executeStep()) { }
}

DAISYDB.prototype.removeNote = function(note) {
   var statement = this.connection.createStatement("delete from notes where id=?1");
   if (note.id) {
      statement.bindInt32Parameter(0,note.id);
   } else {
      statement.bindInt32Parameter(0,note);
   }
   while (statement.executeStep()) { }
}

DAISYDB.prototype.getNotes = function(url,limit) {
   var notes = [];
   var statement = this.connection.createStatement("select id,url,updated,xpath,name,note from notes where url=?1"+(limit ? " limit "+limit : ""));
   statement.bindUTF8StringParameter(0,url);
   while (statement.executeStep()) {
      notes.push({
         id: statement.getInt32(0),
         url: statement.getString(1),
         updated: statement.getInt64(2),
         xpath: statement.getString(3),
         name: statement.getString(4),
         note: statement.getString(5)
      });
   }
   return notes;
}

function DAISYBook() {
   this.uris = {};
   this.metadata = {};
   this.xmetadata = {};
   this.manifest = {};
   this.spine = [];
   this.refCount = 0;
   this._quirky = false;
   this.onDestroy = function() {

   }
}

DAISYBook.prototype.isLocal = function() {
   var uri = this.uris["opf"];
   return uri ? uri.substring(0,5)=="file:" : false;
}


DAISYBook.prototype.ref = function() {
}

DAISYBook.prototype.unref = function() {
   if (this.refCount>0) {
      this.refCount--;
      if (this.refCount==0) {
         this.onDestroy();
      }
   }
}

DAISYBook.extensions = {
   ncx: {
      mediaType: "application/x-dtbncx+xml",
      namespace: "http://www.daisy.org/z3986/2005/ncx/"
   },
   opf: {
      mediaType: "application/oebps-package+xml",
      namespace: "http://openebook.org/namespaces/oeb-package/1.0/"
   },
   xml: {
      mediaType: "application/x-dtbook+xml",
      namespace: "http://www.daisy.org/z3986/2005/dtbook/"
   },
   smil: {
      mediaType: "application/smil+xml",
      namespace: "http://www.w3.org/2001/SMIL20/"
   },
   xsl: {
      mediaType: "application/xslt+xml"
   },
   css: {
      mediaType: "text/css"
   },
   _unknown: {
      mediaType: "application/octet-stream"
   }
}

DAISYBook.prototype.init = function() {
}

DAISYBook.prototype.__defineGetter__("title",function() {
   var date = this.metadata["Date"];
   var type = this.xmetadata["Publication.Type"];
   if (type=="Newspaper" || type=="Magazine") {
      return this.metadata["Title"]+", "+date;
   } else {
      return this.metadata["Title"];
   }
});

DAISYBook.prototype.__defineGetter__("quirky",function() {
   return this.navigation ? this.navigation.quirky || this._quirky : this._quirky;
});

DAISYBook.prototype.findByMediaType = function(mediaType) {
   for (var id in this.manifest) {
      var entry = this.manifest[id];
      if (entry.mediaType==mediaType) {
         return entry;
      }
   }
}

DAISYBook.prototype.findByExtension = function(extension) {
   var test = new RegExp("."+extension+"$");
   var compare = "."+extension;
   for (var id in this.manifest) {
      var entry = this.manifest[id];
      if (entry.href.match(test)==compare) {
         return entry;
      }
   }
}

DAISYBook.prototype.loadPackaging = function(opfDocument,baseURI) {

   if (baseURI) {
      this.uris["opf"] = baseURI;
   }
   // Load metadata from opf file
   var util = DOMUtil.getInstance();
   var current = this;

   this.metadata = {};
   this.xmetadata = {};
   this.manifest = {};
   this.spine = [];

   util.forChildNS(opfDocument.documentElement,"metadata","http://openebook.org/namespaces/oeb-package/1.0/",function(metadata) {
      util.forChildNS(metadata,"dc-metadata","http://openebook.org/namespaces/oeb-package/1.0/",function(dcmetadata) {
         util.forChildNS(dcmetadata,null,"http://purl.org/dc/elements/1.1/",function(dc) {
            current.metadata[dc.localName] = dc.textContent;
            DAISYService.console.debug("metadata["+dc.localName+"] = "+dc.textContent);
         });
         util.forChildNS(dcmetadata,null,"http://purl.org/dc/elements/1.0/",function(dc) {
            current.metadata[dc.localName] = dc.textContent;
            DAISYService.console.debug("metadata["+dc.localName+"] = "+dc.textContent);
         });
      });
      util.forChildNS(metadata,"x-metadata","http://openebook.org/namespaces/oeb-package/1.0/",function(xmetadata) {
         util.forChildNS(xmetadata,"meta","http://openebook.org/namespaces/oeb-package/1.0/",function(meta) {
            var name = meta.getAttribute("name");
            if (name) {
               var content =  meta.getAttribute("content");
               current.xmetadata[name] = content;
               DAISYService.console.debug("xmetadata["+name+"] = "+content);
            }
         });
      });
   });

   util.forChildNS(opfDocument.documentElement,"manifest","http://openebook.org/namespaces/oeb-package/1.0/",function(manifest) {
      util.forChildNS(manifest,"item","http://openebook.org/namespaces/oeb-package/1.0/",function(item) {
         var o = {
            id: item.getAttribute("id"),
            mediaType: item.getAttribute("media-type"),
            href: item.getAttribute("href"),
            resolve: function() {
               var suri = current.uris["opf"];
               if (suri) {
                  var baseURI = new URI(suri);
                  return baseURI.resolve(this.href);
               } else {
                  return this.href;
               }
            }
         };
         current.manifest[o.id] = o;
      });
   });

   util.forChildNS(opfDocument.documentElement,"spine","http://openebook.org/namespaces/oeb-package/1.0/",function(spine) {
      util.forChildNS(spine,"itemref","http://openebook.org/namespaces/oeb-package/1.0/",function(itemref) {
         current.spine.push(itemref.getAttribute("idref"));
      });
   });
}

DAISYBook.prototype.isValid = function() {
   //var ncx = this.findByMediaType("application/x-dtbncx+xml");
   var dtbook = this.findByMediaType("application/x-dtbook+xml");
   return dtbook!=null;
}

DAISYBook.prototype.loadNavigation = function(force) {
   if (this.navigation && !force) {
      return this.navigation;
   }
   var entry = this.findByMediaType("application/x-dtbncx+xml");
   if (entry==null) {
      return null;
   }

   var xmlDoc = null;
   var url = entry.resolve();
   DAISYService.console.debug("Loading navigation "+url.spec);
   HTTP("GET",url.spec,{
      synchronizedRequest: true,
      overrideMimeType: "text/xml",
      onSuccess: function(status,doc) {
         xmlDoc = doc;
      },
      onFailure: function(status,doc) {
         DAISYService.console.log("Cannot load XML document "+url.spec+", status="+status);
      }
   });
   if (!xmlDoc) {
      throw "Cannot load XML document "+uri.spec+" from book.";
   }

   return this.loadNavigationFromDocument(xmlDoc);
}

DAISYBook.prototype.loadNavigationFromDocument = function(xmlDoc) {
   this.navigation = DAISYNavigationControl.load(xmlDoc);
   this._quirky = this.navigation.quirky || this._quirky;
   return this.navigation;
}


DAISYBook.prototype.removeNotes = function(notes) {
   for (var i=0; i<notes.length; i++) {
      var notePoint = notes[i].point;
      if (notePoint) {
         var parent = notePoint.parent;
         if (parent) {
            // remove the point from the navigation
            for (var j=0; j<parent.children.length; j++) {
               if (parent.children[j]==notes[i]) {
                  parent.children.splice(j,1);
                  break;
               }
            }
         }
      }
   }
}

DAISYBook.prototype.removeNote = function(note) {
   var parent = note.point.parent;
   if (note.point.next) {
      note.point.next.previous = note.point.previous;
   }
   if (note.point.previous) {
      note.point.previous.next = note.point.next;
   }
   for (var i=0; i<parent.children.length; i++) {
      if (parent.children[i]==note.point) {
         parent.children.splice(i,1);
         break;
      }
   }

}

DAISYBook.prototype.addNotes = function(notes,comparator) {
   DAISYService.console.debug("updating notes on book "+this.title);
   if (this.navigation && comparator && this.navigation.navMap.children.length>0) {
      DAISYService.console.debug("Adding notes to navigation.");
      for (var i=0; i<notes.length; i++) {
         this.addNote(notes[i],comparator);
      }
   }
}

DAISYBook.prototype.addNote = function(note,comparator) {
   DAISYService.console.debug("note: "+note.id+", "+note.name);
   var point = this.navigation.navMap.children[0];
   while (point.parent && comparator(point,note)<0) {
      DAISYService.console.debug("At "+point.content.id);
      if (point.children.length>0) {
         point = point.children[0];
      } else if (point.next) {
         point = point.next;
      } else {
         while (point.parent && !point.next) {
            point = point.parent;
         }
         if (point.next) {
            point = point.next;
         }
      }
   }
   DAISYService.console.debug("point: "+point.content.id);
   if (point==this.navigation.navMap) {
      point = this.navigation.navMap.children[0];
   }

   var newPoint = new DAISYNavigationPoint(point.parent);
   newPoint.labels.push({
      text: "Note: "+note.name
   });
   newPoint.className = "note";
   newPoint.note = note;
   newPoint.content.id = "daisy-user-note-ref-"+note.id;

   // insert just before item
   for (var c=0; c<point.parent.children.length; c++) {
      if (point.parent.children[c]==point) {
         point.parent.children.splice(c,0,newPoint)
         if (c>0) {
            point.parent.children[c-1].next = newPoint;
            newPoint.previous = point.parent.children[c-1];
         }
         if ((c+1)<point.parent.children.length){
            point.parent.children[c+1].previous = newPoint;
            newPoint.next = point.parent.children[c+1];
         }
         //DAISYService.console.log("Note "+note.id+" previous: "+(newPoint.previous ? newPoint.previous.content.id : null));
         //DAISYService.console.log("Note "+note.id+" next: "+(newPoint.next ? newPoint.next.content.id : null));
         break;
      }
   }
   note.point = newPoint;
}


function DAISYNavigationPoint(parent) {
   this.parent = parent;
   this.labels = [];
   this.next = null;
   this.previous = null;
   this.content = {};
   this.children = [];
}

function DAISYNavigationControl() {
   this.tests = {};
   this.metadata = {};
   this.title = {};
   this.authors = [];
   this.pages = {};
   this.pages.info = [];
   this.pages.labels = [];
   this.pages.list = [];
   this.navList = {};
   this.navList.info = [];
   this.navList.labels = [];
   this.navList.list = [];
   this.navMap = new DAISYNavigationPoint();
}

DAISYNavigationControl.NS = "http://www.daisy.org/z3986/2005/ncx/";

DAISYNavigationControl.allowQuirks = true;

DAISYNavigationControl.load = function(ncxDocument,allowQuirks) {
   var ncx = new DAISYNavigationControl();
   var util = DOMUtil.getInstance();
   var quirks = DAISYNavigationControl.allowQuirks || allowQuirks;
   if (ncxDocument.documentElement.namespaceURI!=DAISYNavigationControl.NS) {
      ncx.quirky = true;
   }
   util.forChildNS(ncxDocument.documentElement,"head",quirks ? null : DAISYNavigationControl.NS,function(head) {
      util.forChildNS(head,"smilCustomTest",DAISYNavigationControl.NS,function(customTest) {
         var test = {}
         test.id = customTest.getAttribute("id");
         test.defaultState = "true"==customTest.getAttribute("defaultState");
         test.override = "true"==customTest.getAttribute("override");
         if (!test.override) {
            test.override = "hidden";
         }
         test.bookStruct = "true"==customTest.getAttribute("bookStruct");
         ncx.tests[test.id] = test;
      });
      util.forChildNS(head,"meta",quirks ? null : DAISYNavigationControl.NS,function(meta) {
         var data = {}
         if (quirks && !ncx.quirky && meta.namespaceURI!=DAISYNavigationControl.NS) {
            ncx.quirky = true;
         }
         data.name = meta.getAttribute("name");
         data.content = meta.getAttribute("content");
         data.scheme = meta.getAttribute("scheme");
         ncx.metadata[data.name] = data;
      });
   });
   util.forChildNS(ncxDocument.documentElement,"docTitle",quirks ? null : DAISYNavigationControl.NS,function(docTitle) {
      if (quirks && !ncx.quirky && docTitle.namespaceURI!=DAISYNavigationControl.NS) {
         ncx.quirky = true;
      }
      ncx.authors.push(DAISYNavigationControl.loadLabel(docTitle));
   });
   util.forChildNS(ncxDocument.documentElement,"docAuthor",quirks ? null : DAISYNavigationControl.NS,function(docAuthor) {
      if (quirks && !ncx.quirky && docAuthor.namespaceURI!=DAISYNavigationControl.NS) {
         ncx.quirky = true;
      }
      ncx.authors.push(DAISYNavigationControl.loadLabel(docAuthor));
   });
   util.forChildNS(ncxDocument.documentElement,"navMap",quirks ? null : DAISYNavigationControl.NS,function(navMap) {
      if (quirks && !ncx.quirky && navMap.namespaceURI!=DAISYNavigationControl.NS) {
         ncx.quirky = true;
      }
      var previous = null;
      util.forChildNS(navMap,"navPoint",quirks ? null : DAISYNavigationControl.NS,function(navPoint) {
         if (quirks && !ncx.quirky && navPoint.namespaceURI!=DAISYNavigationControl.NS) {
            ncx.quirky = true;
         }
         var point = DAISYNavigationControl.loadNavigationPoint(ncx.navMap,navPoint,quirks);
         point.previous = previous;
         if (previous) {
            previous.next = point;
         }
         previous = point;
      });
   });
   util.forChildNS(ncxDocument.documentElement,"pageList",quirks ? null : DAISYNavigationControl.NS,function(pageList) {
      if (quirks && !ncx.quirky && pageList.namespaceURI!=DAISYNavigationControl.NS) {
         ncx.quirky = true;
      }
      util.forChildNS(pageList,"navInfo",quirks ? null : DAISYNavigationControl.NS,function(navInfo) {
         if (quirks && !ncx.quirky && navInfo.namespaceURI!=DAISYNavigationControl.NS) {
            ncx.quirky = true;
         }
         ncx.pages.info.push(DAISYNavigationControl.loadLabel(navInfo));
      });
      util.forChildNS(pageList,"navLabel",quirks ? null : DAISYNavigationControl.NS,function(navLabel) {
         if (quirks && !ncx.quirky && navLabel.namespaceURI!=DAISYNavigationControl.NS) {
            ncx.quirky = true;
         }
         ncx.pages.labels.push(DAISYNavigationControl.loadLabel(navLabel));
      });
      var previous = null;
      util.forChildNS(pageList,"pageTarget",quirks ? null : DAISYNavigationControl.NS,function(pageTarget) {
         if (quirks && !ncx.quirky && pageTarget.namespaceURI!=DAISYNavigationControl.NS) {
            ncx.quirky = true;
         }
         var point = DAISYNavigationControl.loadNavigationPoint(null,pageTarget,quirks);
         ncx.pages.list.push(point);
         point.previous = previous;
         if (previous) {
            previous.next = point;
         }
         previous = point;
      });
   });
   util.forChildNS(ncxDocument.documentElement,"navList",quirks ? null : DAISYNavigationControl.NS,function(navList) {
      if (quirks && !ncx.quirky && navList.namespaceURI!=DAISYNavigationControl.NS) {
         ncx.quirky = true;
      }
      util.forChildNS(navList,"navInfo",quirks ? null : DAISYNavigationControl.NS,function(navInfo) {
         if (quirks && !ncx.quirky && navInfo.namespaceURI!=DAISYNavigationControl.NS) {
            ncx.quirky = true;
         }
         ncx.navList.info.push(DAISYNavigationControl.loadLabel(navInfo));
      });
      util.forChildNS(navList,"navLabel",quirks ? null : DAISYNavigationControl.NS,function(navLabel) {
         if (quirks && !ncx.quirky && navLabel.namespaceURI!=DAISYNavigationControl.NS) {
            ncx.quirky = true;
         }
         ncx.navList.labels.push(DAISYNavigationControl.loadLabel(navLabel));
      });
      var previous = null;
      util.forChildNS(navList,"navTarget",quirks ? null : DAISYNavigationControl.NS,function(pageTarget) {
         if (quirks && !ncx.quirky && pageTarget.namespaceURI!=DAISYNavigationControl.NS) {
            ncx.quirky = true;
         }
         var point = DAISYNavigationControl.loadNavigationPoint(null,pageTarget,quirks);
         ncx.navList.list.push(point);
         point.previous = previous;
         if (previous) {
            previous.next = point;
         }
         previous = point;
      });
   });
   return ncx;
}

DAISYNavigationControl.loadNavigationPoint = function(parent,element,allowQuirks) {

   var quirks = DAISYNavigationControl.allowQuirks || allowQuirks;
   var point = new DAISYNavigationPoint(parent);
   if (parent) {
      parent.children.push(point);
   }
   var util = DOMUtil.getInstance();
   util.forChildNS(element,"navLabel",quirks ? null : DAISYNavigationControl.NS,function(label) {
      point.labels.push(DAISYNavigationControl.loadLabel(label));
   });
   util.forChildNS(element,"content",quirks ? null : DAISYNavigationControl.NS,function(content) {
      var src = content.getAttribute("src")
      var pos = src.indexOf('#');
      point.content.href = src.substring(0,pos);
      point.content.id = src.substring(pos+1);
   });
   var previous = null;
   util.forChildNS(element,"navPoint",quirks ? null : DAISYNavigationControl.NS,function(navPoint) {
      var child = DAISYNavigationControl.loadNavigationPoint(point,navPoint,quirks);
      child.previous = previous;
      if (previous) {
         previous.next = child;
      }
      previous = child;
   });
   return point;
}

DAISYNavigationControl.loadLabel = function(label) {
   var obj = {};
   DOMUtil.getInstance().forElement(label,function(part) {
      if (part.localName=="text") {
         obj.text = part.textContent;
      } else if (part.localName=="audio") {
         obj.audio = {};
         obj.audio.src = part.getAttribute("src");
         obj.audio.clipBegin = part.getAttribute("src");
         obj.audio.clipEnd = part.getAttribute("src");
      } else if (part.localName=="img") {
         obj.image = {};
         obj.image.src = part.getAttribute("src");
      }
   });
   return obj;
}


function DAISYLibrary(service,dir) {
   this.service = service;
   this.dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
   this.dir.initWithPath(dir);
   this.booksByURI = {};
   this.books = [];
}

DAISYLibrary.prototype.findByURI = function(uri) {
   return this.booksByURI[uri];
}

DAISYLibrary.prototype.load = function() {
   var dirEntries = this.dir.directoryEntries;
   var zipTest = /\.zip$/;
   var bks2Test = /\.bks2$/;
   var bookDirs = {};
   var bookZips = {};
   while (dirEntries.hasMoreElements()) {
      var file = dirEntries.getNext().QueryInterface(Components.interfaces.nsIFile);
      if (file.leafName.match(zipTest) || file.leafName.match(bks2Test)) {
         bookZips[file.path] = file;
      } else if (file.isDirectory()) {
         DAISYService.console.debug("Loading book from directory "+file.path);
         bookDirs[file.path] = file;
         var bookDirEntries = file.directoryEntries;
         var opfTest = /\.opf$/;
         var current = this;
         while (bookDirEntries.hasMoreElements()) {
            var bookFile = bookDirEntries.getNext().QueryInterface(Components.interfaces.nsIFile);
            if (bookFile.leafName.match(opfTest)) {
               DAISYService.console.debug("Found OPF document "+bookFile.path);
               var url = DAISYService.fileURL(bookFile);
               HTTP("GET",url.spec,{
                  synchronizedRequest: true,
                  overrideMimeType: "text/xml",
                  onSuccess: function(status,doc) {
                     var book = new DAISYBook(current);
                     book.init();
                     book.loadPackaging(doc,url.spec);
                     current.books.push(book);
                     current.booksByURI[book.uris["opf"]] = book;
                     DAISYService.console.debug("Book "+file.path+" loaded.");
                  },
                  onFailure: function(status,doc) {
                     DAISYService.console.log("Cannot load opf document "+url.spec+", status="+status);
                  }
               });
               break;
            }
         }
      }
   }
   for (var z in bookZips) {
      var zipFile = bookZips[z];
      try {
         var bookDir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
         bookDir.initWithPath(this.dir.path);
         var pos = zipFile.leafName.lastIndexOf(".zip");
         if (pos<0) {
            pos = zipFile.leafName.lastIndexOf(".bks2");
         }
         var dirName = zipFile.leafName.substring(0,pos)
         bookDir.appendRelativePath(dirName);
         if (!bookDirs[bookDir.path]) {
            DAISYService.console.debug("Loading possible book zip "+zipFile.path);
            try {
               var result = this.service.readZipPackaging(zipFile);
               if (result.document) {
                  var book = new DAISYBook();
                  book.init();
                  book.loadPackaging(result.document,result.baseURI);
                  book.zipFile = zipFile;
                  this.books.push(book);
                  this.booksByURI[book.uris["opf"]] = book;
                  DAISYService.console.debug("Book "+zipFile.path+" loaded.");
               } else {
                  DAISYService.console.debug("No OPF document in zip "+zipFile.path);
               }
            } catch (ex) {
               DAISYService.console.log("Cannot read opf document from "+zipFile.path+" due to: "+ex);
            }
         } else {
            DAISYService.console.debug("Skipping zip "+zipFile.path+" as book is extracted.");
         }
      } catch (ex) {
         DAISYService.console.log("Cannot load book "+zipFile.leafName+" due to: "+ex);
      }

   }
   
}


DAISYLibrary.prototype.readZipManifest = function(zipFile) {
   var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
   file.initWithPath(zipFile);
   var zipReader = Components.classes["@mozilla.org/libjar/zip-reader;1"].createInstance(Components.interfaces.nsIZipReader);
   zipReader.open(file)

   var manifest = {
      entries: []
   };

   try {

      var entryIterator = zipReader.findEntries(null);

      var extensionTest = /\.([^\.]+)$/;
      while (entryIterator.hasMore()) {
         var entry = {
            path: entryIterator.getNext()
         };
         var ext = entry.path.match(extensionTest);
         if (ext) {
            entry.extension = ext[1];
            entry.metadata = DAISYBook.extensions[entry.extension];
         } else if (entry.path.charAt(entry.path.length-1)=='/') {
            entry.isFolder = true;
         }
         if (!entry.metadata) {
            entry.metadata = entry._unknown;
         }
         DAISYService.console.debug(entry.path+" -> "+entry.extension);
         manifest.entries.push(entry);
         if (entry.extension=="opf") {
            manifest.opfEntry = entry;
         }
      }

   } catch (ex) {
      zipReader.close();
      throw ex;
   }
   zipReader.close();
   return manifest;
}


DAISYLibrary.prototype.addBookFromZip = function(filename) {

   var bookFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
   bookFile.initWithPath(filename);
   if (!bookFile.exists()) {
      throw "File "+bookFile.path+" does not exist.";
   }

   var result = this.service.readZipPackaging(bookFile);
   if (!result.document) {
      throw "No OPF document in zip "+filename+".  It is possible this is not a packaged DAISY book.";
   }

   var libraryFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
   libraryFile.initWithPath(this.dir.path);
   libraryFile.appendRelativePath(bookFile.leafName);

   if (libraryFile.exists()) {
      throw "The book "+bookFile.leafName+" already exists.";
   }

   bookFile.copyTo(this.dir,bookFile.leafName);

   // re-read from library location
   result = this.service.readZipPackaging(libraryFile);
   if (!result.document) {
      throw "No OPF document in zip "+filename+".  It is possible this is not a packaged DAISY book.";
   }

   var book = new DAISYBook();
   book.init();
   book.loadPackaging(result.document,result.baseURI);
   book.zipFile = libraryFile;
   this.books.push(book);
   this.booksByURI[book.uris["opf"]] = book;
   DAISYService.console.debug("Book "+libraryFile.path+" loaded.");
   return book;
}


function DAISYXHTMLContext(renderer,book,target) {
   this.renderer = renderer;
   this.book = book;
   this.target = target;
}

DAISYXHTMLContext.prototype.show = function(xmlDoc) {
   if (!xmlDoc) {
      var entry = this.book.findByMediaType("application/x-dtbook+xml");
      if (!entry) {
         throw "Cannot find dtbook type in manifest.";
      }
      var url = entry.resolve();
      HTTP("GET",url.spec,{
         synchronizedRequest: true,
         overrideMimeType: "text/xml",
         onSuccess: function(status,doc) {
            xmlDoc = doc;
         },
         onFailure: function(status,doc) {
            DAISYService.console.log("Cannot load XML document "+url.spec+", status="+status);
         }
      });
   }
   if (!xmlDoc) {
      throw "Cannot load XML document from book.";
   }

   var sbase = xmlDoc.baseURI;
   for (var i=sbase.length-1; i>0 && sbase.charAt(i)!='/'; i--);
   if (i>0) {
      sbase = sbase.substring(0,i+1);
   }

   this.renderer.xhtmlTransform.setParameter("","base-uri",sbase);
   this.renderer.xhtmlTransform.setParameter("","no-images",this.renderer.service.showImages ? "" : "true");
   var fragment = this.renderer.xhtmlTransform.transformToFragment(xmlDoc,this.target.ownerDocument);
   var node = fragment.firstChild;
   while (node) {
      this.target.appendChild(node);
      node = node.nextSibling;
   }
   if (this.onload) {
      this.onload();
   }
   return true;
}

function DAISYGalleyContext(renderer,book,target,soundManager) {
   this.index = 0;
   this.renderer = renderer;
   this.book = book;
   this.length = this.book.spine.length;
   this.target = target;
   this.soundManager = soundManager;
   this.sound = true;
   this.focusFollow = true;
   this.currentSpine = -1;
   this.generateSMIL = false;
   var entry = this.book.findByMediaType("application/x-dtbncx+xml");
   if (!entry) {
      entry = this.book.findByMediaType("application/x-dtbook+xml");
   }
   if (!entry) {
      throw "Cannot find dtbook or ncx type in manifest.";
   }
   this.baseURI = entry.resolve();
   var current = this;
   this.onNextSpine = function() {
      current.next();
   }
   this.onFinish = function() {o
      if (current.onNextSpine) {
         current.onNextSpine();
      }
   };
}

DAISYGalleyContext.prototype.show = function() {
   return this.next();
}

DAISYGalleyContext.prototype.proceed = function() {
   this.context.proceed();
}
DAISYGalleyContext.prototype.previous = function() {
   if (this.generateSMIL) {
      return;
   }
   this.index = this.currentSpine-1;
   if (this.index<0) {
      this.index = 0;
   }
   return this.next();
}

DAISYGalleyContext.prototype.next = function() {

   if (this.generateSMIL && this.currentSpine<0) {
      DOMUtil.getInstance().clearChildren(this.target);
      this.currentSpine = 0;
      this.showGeneratedSMIL();
      return;
   }

   if (this.index>=this.book.spine.length) {
      return false;
   }

   this.currentSpine = this.index;

   DOMUtil.getInstance().clearChildren(this.target);

   var item = this.book.manifest[this.book.spine[this.index]];
   while (!item && this.index<this.book.spine.length) {
      DAISYService.console.log("Missing spine item: "+this.book.spine[i]);
      this.index++;
   }
   this.index++;
   var url = this.baseURI.resolve(item.href);
   this.currentContext = this.renderer.renderSMIL(this,url.spec,this.target,this.soundManager);
   return true;
}

DAISYGalleyContext.prototype.showGeneratedSMIL = function() {
   var smilDoc = this.renderer.generateSMILDocument(this.book);
   if (!smilDoc) {
      throw "Cannot generate SMIL from XML document in book.";
   }

   var entry = this.book.findByMediaType("application/x-dtbook+xml");
   if (!entry) {
      throw "Cannot find dtbook type in manifest.";
   }
   var url = entry.resolve();
   
   this.currentContext = this.renderer.renderSMIL(this,{ document: smilDoc, baseURI: url.spec},this.target,this.soundManager);
}

DAISYGalleyContext.prototype.cancel = function() {
   if (this.currentContext) {
      this.currentContext.cancel();
      this.currentContext = null;
   }
}

DAISYGalleyContext.prototype.toggleSound = function(flag) {
   if (this.context) {
      this.context.options.sound = flag;
   }
   this.sound = flag;
}

DAISYGalleyContext.prototype.toggleFollowPosition = function(flag) {
   if (this.context) {
      this.context.options.focusFollow = flag;
   }
   this.focusFollow = flag;
}

function DAISYRenderer(service)
{
   this.service = service;
   this.smilTransform = null;
   this.xhtmlTransform = null;
}

DAISYRenderer.prototype.setSMILTransform = function(url) {
   this.smilTransform = Components.classes["@mozilla.org/document-transformer;1?type=xslt"].createInstance(Components.interfaces.nsIXSLTProcessor);
   var current = this;
   HTTP("GET",url,{
      synchronizedRequest: true,
      overrideMimeType: "text/xml",
      onSuccess: function(status,doc) {
         try {
            current.smilTransform.importStylesheet(doc);
         } catch (ex) {
            DAISYService.console.log("Cannot load SMIL transform: "+ex);
         }
      },
      onFailure: function(status,doc) {
         DAISYService.console.log("Cannot load SMIL transform document "+url+", status="+status);
      }
   });
}

DAISYRenderer.prototype.setXHTMLTransform = function(url) {
   this.xhtmlTransform = Components.classes["@mozilla.org/document-transformer;1?type=xslt"].createInstance(Components.interfaces.nsIXSLTProcessor);
   var current = this;
   HTTP("GET",url,{
      synchronizedRequest: true,
      overrideMimeType: "text/xml",
      onSuccess: function(status,doc) {
         try {
            current.xhtmlTransform.importStylesheet(doc);
         } catch (ex) {
            DAISYService.console.log("Cannot load XHTML transform: "+ex);
         }
      },
      onFailure: function(status,doc) {
         DAISYService.console.log("Cannot load XHTML transform document "+url+", status="+status);
      }
   });
}

DAISYRenderer.prototype.generateSMILDocument = function(book) {
   var entry = book.findByMediaType("application/x-dtbook+xml");
   if (!entry) {
      throw "Cannot find dtbook type in manifest.";
   }
   var url = entry.resolve();
   this.smilTransform.setParameter("","base-uri",url.spec);
   var xmlDoc = null;
   HTTP("GET",url.spec,{
      synchronizedRequest: true,
      overrideMimeType: "text/xml",
      onSuccess: function(status,doc) {
         xmlDoc = doc;
      },
      onFailure: function(status,doc) {
         DAISYService.console.log("Cannot load XML document "+url.spec+", status="+status);
      }
   });
   if (!xmlDoc) {
      throw "Cannot load XML document "+url.spec+" from book.";
   }

   var smilDoc = this.smilTransform.transformToDocument(xmlDoc);
   if (DAISYService.preferences.debug) {
      var serializer = new XMLSerializer();
      DAISYService.console.debug(serializer.serializeToString(smilDoc));
   }
   return smilDoc;
}


DAISYRenderer.prototype.galleyRender = function(book,target,soundManager) {
   return new DAISYGalleyContext(this,book,target,soundManager);
}

DAISYRenderer.prototype.xhtmlRender = function(book,target) {
   return new DAISYXHTMLContext(this,book,target);
}

DAISYRenderer.prototype.renderSMIL = function(renderContext,object,region,soundManager) {
   var smilDoc = typeof object == "string" ? null : object.document;
   var baseURI = typeof object == "string" ? object : object.baseURI;
   if (!smilDoc) {
      HTTP("GET",object, {
         overrideMimeType: "text/xml",
         synchronizedRequest: true,
         onSuccess: function(status,xml,text) {
            smilDoc = xml;
         },
         onFailure: function(status) {
            throw "Cannot get smil document from "+object+", status="+status;
         }
      });
   }
   var smil = this.service.smil.load(smilDoc);
   var current = this;
   renderContext.document = smil;
   var context = current.service.smil.createContext(region,null,{
      onWaitForUserEscape: renderContext.onWaitForUserEscape,
      onFinish: renderContext.onFinish,
      sound: renderContext.sound,
      focusFollow: renderContext.focusFollow,
      resourceManager: current.service.smil.createResourceManager(baseURI),
      soundManager: soundManager
   });
   renderContext.context = context;
   smil.play(context);
   return context;
}

DAISYRenderer.prototype.createNavigationContext = function(book,navigation,options) {
   return new DAISYNavigationContext(this,book,navigation,options);
}

function DAISYNavigationContext(renderer,book,navigation,options) {
   this.renderer = renderer;
   this.book = book;
   this.navigation = navigation;
   this.smilCache = {};
   this.options = options;
   this.quirky = false;
   var entry = this.book.findByMediaType("application/x-dtbncx+xml");
   if (!entry) {
      entry = this.book.findByMediaType("application/x-dtbook+xml");
   }
   if (!entry) {
      throw "Cannot find dtbook or ncx type in manifest.";
   }
   this.baseURI = entry.resolve();
   this.console = DAISYService.console;
}

DAISYNavigationContext.prototype.getSMIL = function(name) {
   var obj = this.smilCache[name];
   if (!obj) {
      var url = this.baseURI.resolve(name);
      var smilDoc = null;
      HTTP("GET",url.spec, {
         overrideMimeType: "text/xml",
         synchronizedRequest: true,
         onSuccess: function(status,xml,text) {
            smilDoc = xml;
         },
         onFailure: function(status) {
            throw "Cannot get smil document from "+url.spec+", status="+status;
         }
      });
      if (!smilDoc) {
         throw "Cannot get smil document for "+name;
      }
      var smilObj = this.renderer.service.smil.load(smilDoc);
      this.quirky = this.quirky || smilObj.quirky;
      obj = {
         smil: smilObj,
         resourceManager: this.renderer.service.smil.createResourceManager(url.spec)
      };
      this.smilCache[name] = obj;
   }
   return obj;
}

DAISYNavigationContext.findPosY = function(obj) {
   var curtop = 0;
   if (obj.offsetParent) {
      while (obj.offsetParent) {
         curtop += obj.offsetTop;
         obj = obj.offsetParent;
      }
   } else if (obj.y) {
      curtop += obj.y;
   }
   return curtop;
}

DAISYNavigationContext.prototype.moveToPage = function(page,focus,hash) {
   var pageNo = ""+page;
   var element = this.document.defaultView.pages[page];
   if (!element) {
      DAISYService.console.log("Cannot find element for page "+page);
      return;
   }
   var id = element.getAttribute("id");
   if (id) {
      //DAISYService.console.log("Move to id: "+id);
      if (focus) {
         element.focus();
      }
      if (hash) {
         this.document.defaultView.location.hash = "#"+id;
      }
      this.moveTo(id);
      return id;
   } else {
      DAISYService.console.log("Page target does not have an id.");
      return null;
   }
}

DAISYNavigationContext.prototype.moveTo = function(id,offset) {
   var target = this.document.getElementById(id);
   if (target) {
      var y = DAISYNavigationContext.findPosY(target);
      if (offset) {
         y += offset;
      } else {
         //y -= 30;
      }
      target.ownerDocument.defaultView.scroll(0,y);
      //target.focus();
   } else {
      DAISYService.console.log("Cannot find element with id "+id);
   }
}

DAISYNavigationContext.prototype.stop = function() {
   if (this.playContext) {
      this.playContext.cancel();
      this.playContext = null;
   }
}

DAISYNavigationContext.prototype.seek = function(id)
{
   var target = this.document.getElementById(id);
   if (target) {
      var smilref = target.ownerDocument.defaultView.smilref[id]
      if (!smilref) {
         DAISYService.console.log("Cannot find smilref for #"+id);
         return false;
      }
      /*
      var smilObj = null;
      var smilTarget = null;
      for (var mid in this.book.manifest) {
         var item = this.book.manifest[mid];
         if (item.mediaType.indexOf("application/smil")==0) {
            smilObj = this.getSMIL(item.href);
            smilTarget = smilObj.smil.objects[id];
            if (!smilTarget) {
               smilObj = null;
            } else {
               break;
            }
         }
      }
      */
      /*
      var smilObj = this.getSMIL(this.currentPoint.content.href);
      var smilTarget = smilObj.smil.objects[id];
      */
      var hashPos = smilref.indexOf("#");
      var href = smilref.substring(0,hashPos);
      var smilId = smilref.substring(hashPos+1);
      var smilObj = this.getSMIL(href);
      var smilTarget = smilObj.smil.objects[smilId];
      if (!smilTarget) {
         DAISYService.console.log("Cannot find #"+smilId+" in SMIL "+href+" for target #"+id);
         return false;
      }
      DAISYService.console.log("Playing #"+smilId+" in SMIL "+href+" for target #"+id);
      this._playTarget(target,smilObj,smilTarget);
      return true;
   }
   return false;
}

DAISYNavigationContext.prototype.play = function(navPoint) {
   if (navPoint) {
      this.currentPoint = navPoint;
   } else if (this.currentPoint) {
      navPoint = this.currentPoint;
   } else {
      return false;
   }
   var target = this.document.getElementById(navPoint.content.id);
   if (target) {
      var smilObj = this.getSMIL(navPoint.content.href);
      var smilTarget = smilObj.smil.objects[navPoint.content.id];
      if (!smilTarget) {
         //throw "Cannot find target "+navPoint.content.id+" in SMIL "+navPoint.content.href;
         return false;
      }
      this._playTarget(target,smilObj,smilTarget);
      return true;
   } else {
      return false;
   }
}

DAISYNavigationContext.prototype._playTarget = function(target,smilObj,smilTarget) {
   var current = this;
   var currentOnFinish = this.options.onFinish;
   var newOptions = {
      onFinish: function() {
         DAISYService.console.debug("play context onFinish called for point: "+smilTarget.id);
         current.playContext = null;
         if (currentOnFinish) {
            currentOnFinish();
         }
      }
   };
   for (var id in this.options) {
      newOptions[id] = this.options[id];
   }
   this.playContext = this.renderer.service.smil.createContext(target,smilTarget.parent,newOptions);
   this.playContext.resourceManager = smilObj.resourceManager;
   this.playContext.options.navigateOnly = true;
   var topContext = this.playContext;
   while (topContext.parent) {
      topContext = topContext.parent;
   }
   topContext.top = true;
   for (var index=0; index<smilTarget.parent.children.length; index++) {
      if (smilTarget.parent.children[index].id==smilTarget.id) {
         smilTarget.parent.restart(this.playContext,index);
         break;
      }
   }
}

DAISYNavigationContext.prototype.next = function(noPlay) {
   while (this.currentPoint && !this.currentPoint.next) {
      this.currentPoint = this.currentPoint.parent;
   }
   if (this.currentPoint && this.currentPoint.next) {
      this.currentPoint = this.currentPoint.next;
      if (!noPlay) {
         this.play();
         return 1;
      } else {
         return 2;
      }
   } else {
      return 0;
   }
}

DAISYNavigationContext.prototype.previous = function(noPlay) {
   while (this.currentPoint && !this.currentPoint.previous) {
      this.currentPoint = this.currentPoint.parent;
   }
   if (this.currentPoint && this.currentPoint.previous) {
      this.currentPoint = this.currentPoint.previous;
      if (!noPlay) {
         this.play();
         return 1;
      } else {
         return 2;
      }
   } else {
      return 0;
   }
}




/*
 *
Copyright (c) 2008, R. Alexander Milowski
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

 - Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.
 - Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.
 - Neither the name of the R. Alexander Milowski nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 *
 */

var _HTTP_HEADER_NAME = new RegExp("^([a-zA-Z0-9_-]+):");
var _ioService=Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
var _authenticationManager = Components.classes["@mozilla.org/network/http-auth-manager;1"].getService(Components.interfaces.nsIHttpAuthManager);

function _HTTP_parseHeaders(headerText)
{
   var headers = {};
   if (headerText) {
      var eol = headerText.indexOf("\n");
      while (eol>=0) {
         var line = headerText.substring(0,eol);
         headerText = headerText.substring(eol+1);
         while (headerText.length>0 && !headerText.match(_HTTP_HEADER_NAME)) {
            eol = headerText.indexOf("\n");
            var nextLine = eol<0 ? headerText : headerText.substring(0,eol);
            line = line+' '+nextLine;
            headerText = eol<0 ? "" : headerText.substring(eol+1);
         }
         // Parse the name value pair
         var colon = line.indexOf(':');
         var name = line.substring(0,colon);
         var value = line.substring(colon+1);
         headers[name] = value;
         eol = headerText.indexOf("\n");
      }
      if (headerText.length>0) {
         var colon = headerText.indexOf(':');
         var name = headerText.substring(0,colon);
         var value = headerText.substring(colon+1);
         headers[name] = value;
      }
   }
   return headers;
}

/** 
 * The following keys can be sent:
 * onSuccess (required)  a function called when the response is 2xx
 * onFailure             a function called when the response is not 2xx
 * username              The username for basic auth
 * password              The password for basic auth
 * overrideMimeType      The mime type to use for non-XML response mime types
 * timeout               A timeout value in milliseconds for the response
 * onTimeout             A function to call if the request times out.
 * body                  A string containing the entity body of the request
 * contentType           The content type of the entity body of the request
 * headers               A hash of optional headers
 */
function HTTP(method,url,options)
{
      
   //alert(method+" "+url+" "+options.username);
   
   var requester = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance();
   requester = requester.QueryInterface(Components.interfaces.nsIXMLHttpRequest);
   //var requester = new XMLHttpRequest();

   var timeout = null;
   if (!options.synchronizedRequest) {

      requester.onreadystatechange = function() {
         if (requester.readyState==4) {
            if (timeout) {
               clearTimeout(timeout);
            }
            try {
               if (requester.status) {
               }
            } catch (ex) {
               if (options.onFailure) {
                  options.onFailure(
                     -1,
                     null,
                     ex,
                     null
                  );
               }
               return;
            }
            try {
               if (requester.status==0 || (requester.status>=200 && requester.status<300)) {
                  options.onSuccess(
                     requester.status,
                     requester.responseXML,
                     requester.responseText,
                     options.returnHeaders ? _HTTP_parseHeaders(requester.getAllResponseHeaders()) : null
                  );
               } else {
                  if (options.onFailure) {
                     options.onFailure(
                        requester.status,
                        requester.responseXML,
                        requester.responseText,
                        options.returnHeaders ? _HTTP_parseHeaders(requester.getAllResponseHeaders()) : null
                     );
                  }
               }
            } catch (ex) {
               if (options.onFailure) {
                  options.onFailure(-1,requester.responseXML,ex);
               }
            }
         }
      }
   }
   
   if (options.overrideMimeType) {
      requester.overrideMimeType(options.overrideMimeType);
   }
   if (options.username && options.username!="") {
      requester.open(method,url+"",!options.synchronizedRequest,options.username,options.password);
   } else {
      requester.open(method,url+"",!options.synchronizedRequest);
   }
   if (options.timeout && !options.synchronizedRequest) {
      timeout = setTimeout(
          function() {
             var callback = options.onTimeout ? options.onTimeout : options.onFailure;
             callback(0,"Operation timeout.");
          },
          options.timeout
      );
   }
   if (options.headers) {
      for (var name in options.headers) {
         requester.setRequestHeader(name,options.headers[name]);
      }
   }
   if (options.body) {
      requester.setRequestHeader("Content-Type",options.contentType);
      requester.send(options.body);
   } else {
      requester.send(null);
   }
   if (options.synchronizedRequest) {
      if (requester.status==0 || (requester.status>=200 && requester.status<300)) {
         options.onSuccess(
            requester.status,
            requester.responseXML,
            requester.responseText,
            options.returnHeaders ? _HTTP_parseHeaders(requester.getAllResponseHeaders()) : null
         );
      } else {
         if (options.onFailure) {
            options.onFailure(
               requester.status,
               requester.responseXML,
               requester.responseText,
               options.returnHeaders ? _HTTP_parseHeaders(requester.getAllResponseHeaders()) : null
            );
         }
      }
      return {
         abort: function() {
         }
      };
   } else {
      return {
         abort: function() {
            clearTimeout(timeout);
            requester.abort();
         }
      };
   }
}



/*
 *
Copyright (c) 2008, R. Alexander Milowski
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

 - Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.
 - Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.
 - Neither the name of the R. Alexander Milowski nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 *
 */

function DOMUtil() {
}

DOMUtil.getInstance = function() {
   if (!DOMUtil.instance) {
      DOMUtil.instance = new DOMUtil();
   }
   return DOMUtil.instance;
}

DOMUtil.prototype.forElement = function(e,handler) {
   var current = e ? e.firstChild : null;
   while (current) {
      if (current.nodeType!=1) {
         current = current.nextSibling;
         continue;
      }
      handler(current);
      current = current.nextSibling;
   }
}

DOMUtil.prototype.forChild = function(e,name,handler) {
   var current = e ? e.firstChild : null;
   while (current) {
      if (current.nodeType!=1) {
         current = current.nextSibling;
         continue;
      }
      //alert("{"+current.namespaceURI+"}"+current.localName+" vs {"+namespace+"}"+name);
      if (current.tagName.toLowerCase()==name) {
         handler(current);
      }
      current = current.nextSibling;
   }
}
DOMUtil.prototype.forChildNS = function(e,name,namespaceURI,handler) {
   var current = e ? e.firstChild : null;
   while (current) {
      if (current.nodeType!=1) {
         current = current.nextSibling;
         continue;
      }
      //alert("{"+current.namespaceURI+"}"+current.localName+" vs {"+namespace+"}"+name);
      if ((!name || current.localName==name) && (!namespaceURI || current.namespaceURI==namespaceURI)) {
         handler(current);
      }
      current = current.nextSibling;
   }
}
DOMUtil.prototype.text = function(e,value) {
   if (value) {
      this.clearChildren(e);
      e.appendChild(e.ownerDocument.createTextNode(value));
   } else {
      if (e.innerText) {
         return e.innerText;
      } else if (e.textContent) {
         return e.textContent;
      } else {
         var text = "";
         var current = e.firstChild;
         while (current) {
            if (current.nodeType==3) {
               text += current.nodeValue;
            } else if (current.nodeType==1) {
               text += this.text(current);
            }
            current = current.nextSibling;
         }
         return text;
      }
   }
}

DOMUtil.prototype.clearChildren = function(parent) {
   if (parent && parent.childNodes) {
      while (parent.childNodes.length>0) {
         parent.removeChild(parent.childNodes.item(0));
      }
   }
}

/*
 * 
Copyright (c) 2008, R. Alexander Milowski
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

 - Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.
 - Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.
 - Neither the name of the R. Alexander Milowski nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 *
 */

function URI(spec) {
   this.spec = spec;
   this.parse();
}

URI.prototype.parse = function() {
   var pos = 0;
   for (; pos<this.spec.length && this.spec.charAt(pos)!=':'; pos++);
   if (pos==this.spec.length) {
      throw "Bad URI value, no scheme: "+this.spec;
   }
   this.scheme = this.spec.substring(0,pos);
   this.schemeSpecificPart = this.spec.substring(pos+1);
   pos++;
   if (this.spec.charAt(pos)=='/' && this.spec.charAt(pos+1)=='/') {
      this.parseGeneric();
   }
}

URI.prototype.parseGeneric = function() {
   if (this.schemeSpecificPart.charAt(0)!='/' || this.schemeSpecificPart.charAt(1)!='/') {
      throw "Generic URI values should start with '//':"+this.spec;
   }

   var work = this.schemeSpecificPart.substring(2);
   var pathStart = work.indexOf("/");
   if (pathStart<0) {
      throw "There must be a server specification: "+this.spec;
   }
   this.authority = work.substring(0,pathStart);
   this.path = work.substring(pathStart);
   var hash = this.path.indexOf('#');
   if (hash>=0) {
      this.fragment = this.path.substring(hash+1);
      this.path = this.path.substring(0,hash);
   }
   var questionMark = this.path.indexOf('?');
   if (questionMark>=0) {
      this.query = this.path.substring(questionMark+1);
      this.path = this.path.substring(0,questionMark);
   }
   this.segments = this.path.split(/\//);
   if (this.segments.length>0 && this.segments[0]=='' && this.path.length>1 && this.path.charAt(1)!='/') {
      // empty segment at the start, remove it
      this.segments.shift();
   }
   if (this.segments.length>0 && this.path.length>0 && this.path.charAt(this.path.length-1)=='/' && this.segments[this.segments.length-1]=='') {
      // we may have an empty the start
      // check to see if it is legimate
      if (this.path.length>1 && this.path.charAt(this.path.length-2)!='/') {
         this.segments.pop();
      }
   }
   this.isGeneric = true;
}

URI.prototype.resolve = function(href) {
   if (!href) {
      return new URI(this.spec);
   }
   if (!this.isGeneric) {
      throw "Cannot resolve uri against non-generic URI: "+this.spec;
   }
   if (href.charAt(0)=='/') {
      return new URI(this.scheme+"://"+this.authority+href);
   } else if (href.charAt(0)!='#') {
      if (href.charAt(0)=='.' && href.charAt(1)=='/') {
         href = href.substring(1);
      }
      if (this.path.charAt(this.path.length-1)=='/') {
         return new URI(this.scheme+"://"+this.authority+this.path+href.substring(2));
      } else {
         var last = this.path.lastIndexOf('/');
         return new URI(this.scheme+"://"+this.authority+this.path.substring(0,last+1)+href);
      }
   } else {
      return new URI(this.scheme+"://"+this.authority+this.path+href);
   }
}

URI.prototype.relativeTo = function(otherURI) {
   if (otherURI.scheme!=this.scheme) {
      return this.spec;
   }
   if (!this.isGeneric) {
      throw "A non generic URI cannot be made relative: "+this.spec;
   }
   if (!otherURI.isGeneric) {
      throw "Cannot make a relative URI against a non-generic URI: "+otherURI.spec;
   }
   if (otherURI.authority!=this.authority) {
      return this.spec;
   }
   for (var i=0; i<this.segments.length && i<otherURI.segments.length; i++) {
      if (this.segments[i]!=otherURI.segments[i]) {
         //alert(this.path+" different from "+otherURI.path+" at '"+this.segments[i]+"' vs '"+otherURI.segments[i]+"'");
         var relative = "";
         for (var j=i; j<otherURI.segments.length; j++) {
            relative += "../";
         }
         for (var j=i; j<this.segments.length; j++) {
            relative += this.segments[j];
            if ((j+1)<this.segments.length) {
               relative += "/";
            }
         }
         if (this.path.charAt(this.path.length-1)=='/') {
            relative += "/";
         }
         return relative;
      }
   }
   if (this.segments.length==otherURI.segments.length) {
      return hash ? hash : (query ? query : "");
   } else if (i<this.segments.length) {
      var relative = "";
      for (var j=i; j<this.segments.length; j++) {
         relative += this.segments[j];
         if ((j+1)<this.segments.length) {
            relative += "/";
         }
      }
      if (this.path.charAt(this.path.length-1)=='/') {
         relative += "/";
      }
      return relative;
   } else {
      throw "Cannot calculate a relative URI for "+this.spec+" against "+otherURI.spec;
   }
}




function setTimeout(handler,delay) {
    var timer = Components.classes["@mozilla.org/timer;1"].createInstance().QueryInterface(Components.interfaces.nsITimer);
    timer.initWithCallback(handler,delay,0);
    return timer;
}

function clearTimeout(timer) {
   timer.cancel();
}

function DAISYProductInfo() {
   this.name = "DAISY Reader";
   this.version = {
      major: 1,
      minor: 0,
      release: 0,
      build: 20090723103706
   };
}
       