Console = {
   preferencesService: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("daisy.client."),
   _initialized: false,
   _debug: false,
   service: Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),
   log: function(message) {
      this.service.logStringMessage(message);
   },
   debug: function(message) {
      if (!this._initialized) {
         if (Console.preferencesService) {
            try {
               //Console.log(Console.preferencesService.prefHasUserValue("debug"));
               Console._debug = Console.preferencesService.getBoolPref("debug");
            } catch (ex) {
               // no preference
            }
         }
         this._initialized = true;
      }
      if (this._debug) {
         this.service.logStringMessage(message);
      }
   }
}

function AddNote() {
   var theClass = Components.classes["@benetech.org/daisy;1"];
   var theComponent = theClass.getService(Components.interfaces.nsISupports);
   this.service = theComponent.wrappedJSObject;
}

AddNote.getInstance = function() {
   if (!AddNote.instance) {
      AddNote.instance = new AddNote();
   }
   return AddNote.instance;
}

AddNote.prototype.init = function(data) {
   this.data = data.wrappedJSObject;
   document.getElementById("name").value = this.data.name;
   var current = this;
   this.uivoice = new UIVoice();
   this.uivoice.init();
   var tm = Components.classes["@mozilla.org/thread-manager;1"].getService(Components.interfaces.nsIThreadManager);
   var ttsCallback = {
      thread: tm.currentThread,
      QueryInterface: function(aIID) {
         if (aIID.equals(Components.interfaces.nsITTSCallback) ||
            aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
            aIID.equals(Components.interfaces.nsISupports)) {
            return this;
         }
         throw Components.results.NS_NOINTERFACE;
      },
      onFinish: function() {
         this.thread.dispatch({
            run: function() {
               current.uivoice.attach(document);
               document.getElementById("name").focus();
            }
         },this.thread.DISPATCH_NORMAL);
      }
   };
   this.uivoice.service.tts.cancel();
   setTimeout(function() {
      current.uivoice.speak("Add Note",ttsCallback);
   },500);
}

AddNote.prototype.onKeyPress = function(event) {
   if (event.keyCode==13) {
      this.onOK();
   }
}

AddNote.prototype.onCancel = function() {
   var current = this;
   setTimeout(function() {
      window.close();
      current.data.onClose();
   },10);
   this.data.success = false;
}

AddNote.prototype.onOK = function() {
   this.data.success = true;
   this.data.name = document.getElementById("name").value;
   this.data.note = document.getElementById("note").value;
   var current = this;
   setTimeout(function() {
      window.close();
      current.data.onClose();
   },10);
}

