Bookshelf.prototype = new Settings();
Bookshelf.prototype.constructor = Bookshelf;

function Bookshelf() {
}

Bookshelf.getInstance = function() {
   if (!Bookshelf.instance) {
      Bookshelf.instance = new Bookshelf();
   }
   return Bookshelf.instance;
}

Bookshelf.prototype.init = function(data) {
   this.libraryDir = this._getPreferenceString("daisy.library.","dir");
   if (!this.libraryDir) {
      var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
      var dir = dirService.get("Desk", Components.interfaces.nsILocalFile);
      dir.appendRelativePath("mydaisy");
      if (!dir.exists()) {
         dir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,0700);
      }
      this.libraryDir = dir.path;
   }
   Console.log("Library directory is "+this.libraryDir);
   this.library = this.service.getLibrary(this.libraryDir);
   if (!this.library) {
      alert("Library directory "+this.libraryDir+" does not exist.");
   }
   try {
      this.filename = document.getElementById("filename");
      this.booklist = document.getElementById("booklist");
      var current = this;
      this.filename.onkeypress = function(event) {
         if (event.keyCode==13) {
            current.addBook();
         } else if (event.shiftKey && event.keyCode==9) {
            setTimeout(function() {current.booklist.focus();},250);
         }
      };
      this.booklist.ondblclick = function() {
         var book = current.library.findByURI(current.booklist.selectedItem.value);
         if (book) {
            current.openBook(book);
         }
      };
      this.booklist.onkeypress = function(event) {
         if (event.keyCode==13) {
            var book = current.library.findByURI(current.booklist.selectedItem.value);
            if (book) {
               current.openBook(book);
            }
         }
      };

      this.booklist.focus();
      for (var i=0; i<this.library.books.length; i++) {
         var item = this.showBook(this.library.books[i]);
      }
      setTimeout(function() {
         current.booklist.clearSelection();
         current.booklist.selectedIndex = 0;
      },250);
      
   } catch (ex) {
      Console.log(ex);
   }
}

Bookshelf.prototype.addBook = function(filename) {
   if (!filename) {
      filename = this.filename.value;
   }
   if (!filename || filename.length==0) {
      return;
   }
   try {
      var book = this.library.addBookFromZip(filename);
      this.showBook(book);
   } catch (ex) {
      alert(ex);
   }
}

Bookshelf.prototype.showBook = function(book) {
   return this.booklist.appendItem(book.title,book.uris["opf"]);
}

Bookshelf.prototype.openBook = function(book) {
   if (!this.ensureUnpacked(book)) {
      return;
   }
   var entry = book.findByMediaType("application/oebps-package+xml");
   if (!entry) {
      entry = book.findByExtension("opf");
   }
   if (!entry) {
      throw "Cannot find OPF document in book manifest.";
   }
   var url = entry.resolve();

   var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
   var mainWindow = windowMediator.getMostRecentWindow("navigator:browser");
   var tabBrowser = mainWindow.getBrowser();

   var browserTab = tabBrowser.addTab(url.spec);
   tabBrowser.selectedTab = browserTab;
   browserTab.linkedBrowser.contentWindow.focus();
}

Bookshelf.prototype.browseForFile = function() {

   var nsIFilePicker = Components.interfaces.nsIFilePicker;
   var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
   fp.init(window, "Choose Book Zip File", nsIFilePicker.modeOpen);
   fp.appendFilter("DAISY Book Archive","*.zip;*.bks2");
   if(fp.show() == nsIFilePicker.returnOK) {
      this.filename.value = fp.file.path;
   }
}

Bookshelf.prototype.addBook = function(filename) {
   if (!filename) {
      filename = this.filename.value;
   }
   if (!filename || filename.length==0) {
      return;
   }
   var book = this.library.addBookFromZip(filename);
   this.showBook(book);
}



