function DAISYOverlay() {
   var theClass = Components.classes["@benetech.org/daisy;1"];
   var theComponent = theClass.getService(Components.interfaces.nsISupports);
   this.count = 0;
   this.service = theComponent.wrappedJSObject;
   this.console = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
   this._windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
   this.tts = null;
   var current = this;
   this.tabListener = function(event) {
      if (current.service.currentHelper) {
         //current.console.logStringMessage("Calling onStop on current helper.");
         current.service.currentHelper.onStop();
         current.service.tts.cancel();
         //} else {
         //current.console.logStringMessage("No current helper.");
      }
      var href = event.target.linkedBrowser.contentWindow.location.href;
      var hash = href.indexOf("#");
      if (hash>0) {
         href = href.substring(0,hash);
      }
      var book = current.service.getBook(href);
      //if (href.match(/.opf$/)==".opf") {
      if (book) {
         //current.console.logStringMessage("Selected DAISY Book tab.");
         var mainWindow = current._windowMediator.getMostRecentWindow("navigator:browser");
         var validPanel  = mainWindow.document.getElementById("daisy-status-bar-valid");
         var quirkyPanel  = mainWindow.document.getElementById("daisy-status-bar-quirky");
         if (book.quirky) {
            validPanel.style.display = "none";
            quirkyPanel.style.display = "block";
         } else {
            validPanel.style.display = "block";
            quirkyPanel.style.display = "none";
         }
      } else {
         if (current.service.readUI && current.service.tts && current.service.active) {
            var text = "Tab, "+event.target.label;
            current.service.tts.speak(text,null);
         }
         var mainWindow = current._windowMediator.getMostRecentWindow("navigator:browser");
         var sidebar  = mainWindow.document.getElementById("sidebar");
         if (sidebar.contentWindow.location.href=="chrome://daisy/content/sidebar.xul") {
            mainWindow.toggleSidebar();
         }
         var validPanel  = mainWindow.document.getElementById("daisy-status-bar-valid");
         var quirkyPanel  = mainWindow.document.getElementById("daisy-status-bar-quirky");
         validPanel.style.display = "none";
         quirkyPanel.style.display = "none";
         //current.console.logStringMessage("Selected web page tab.");

      }
   };
   var quitObserver = {
      QueryInterface: function(aIID) {
         if (aIID.equals(Components.interfaces.nsIObserver) || aIID.equals(Components.interfaces.nsISupports)) {
            return this;
         }
         throw Components.results.NS_NOINTERFACE;
      },
      observe: function(aSubject,aTopic,aData ) {
         current.console.logStringMessage("Topic: "+aTopic);
         // TODO: does this need to iterate all windows?
         var mainWindow = current._windowMediator.getMostRecentWindow("navigator:browser");
         var tabBrowser = mainWindow.getBrowser();
         for (var i=0; i<tabBrowser.tabContainer.itemCount; i++) {
            var tab = tabBrowser.tabContainer.getItemAtIndex(i);
            if (tab.linkedBrowser.contentWindow.helper && tab.linkedBrowser.contentWindow.helper.uitts) {
               try {
                  tab.linkedBrowser.contentWindow.helper.uitts.cancel();
               } catch (ex) {
               }
            }
         }
         var sidebar  = mainWindow.document.getElementById("sidebar");
         if (sidebar.contentWindow.location.href=="chrome://daisy/content/sidebar.xul") {
            if (sidebar.contentWindow.theSidebar && sidebar.contentWindow.theSidebar.tts) {
               sidebar.contentWindow.theSidebar.tts.cancel();
            }
         }
      }
   };

   /* debug code
   var testObserver = {
      QueryInterface: function(aIID) {
         if (aIID.equals(Components.interfaces.nsIObserver) || aIID.equals(Components.interfaces.nsISupports)) {
            return this;
         }
         throw Components.results.NS_NOINTERFACE;
      },
      observe: function(aSubject,aTopic,aData ) {
         current.console.logStringMessage("Topic: "+aTopic);
      }
   };
   */
   setTimeout(function() {
      var mainWindow = current._windowMediator.getMostRecentWindow("navigator:browser");
      var tabBrowser = mainWindow.getBrowser();
      tabBrowser.tabContainer.addEventListener("TabSelect",current.tabListener,false);
      var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
      observerService.addObserver(quitObserver,"quit-application-granted",false);
      /* debug code
      observerService.addObserver(testObserver,"quit-application-requested",false);
      observerService.addObserver(testObserver,"quit-application-granted",false);
      observerService.addObserver(testObserver,"quit-application",false);
      */
   },2000);
}

DAISYOverlay.getInstance = function() {
   if (!DAISYOverlay.instance) {
      DAISYOverlay.instance = new DAISYOverlay();
   }
   return DAISYOverlay.instance;
}

DAISYOverlay.prototype.useCount = function() {
   return this.count++;
}


DAISYOverlay.prototype.show = function() {
   var window = this.service.window;
   if (window) {
      window.focus();
   } else {
      this.console.logStringMessage("Cannot get DAISY player window.");
   }
}

DAISYOverlay.prototype.toggleSidebar = function() {
   var mainWindow = this._windowMediator.getMostRecentWindow("navigator:browser");

   mainWindow.toggleSidebar('openDaisySidebar');

   var sidebar  = mainWindow.document.getElementById("sidebar");
   var current = this;
   setTimeout(function() {
      if (sidebar.contentWindow.location.href=="chrome://daisy/content/sidebar.xul" && sidebar.contentWindow.theSidebar) {
         sidebar.contentWindow.theSidebar.focus();
      }
   },250);

}

DAISYOverlay.prototype.moveTo = function() {
   var mainWindow = this._windowMediator.getMostRecentWindow("navigator:browser");
   var sidebar  = mainWindow.document.getElementById("sidebar");
   if (sidebar.contentWindow.location.href!="chrome://daisy/content/sidebar.xul") {
      mainWindow.toggleSidebar('openDaisySidebar',true);
   }
   var current = this;
   setTimeout(function() {
      if (sidebar.contentWindow.theSidebar) {
         sidebar.contentWindow.theSidebar.focus();
      }
   },250);
}

DAISYOverlay.prototype.moveToBook = function() {
   var mainWindow = this._windowMediator.getMostRecentWindow("navigator:browser");
   var sidebar  = mainWindow.document.getElementById("sidebar");
   if (sidebar.contentWindow.location.href!="chrome://daisy/content/sidebar.xul") {
      return;
   }
   if (sidebar.contentWindow.theSidebar) {
      var sidebarApp = sidebar.contentWindow.theSidebar;
      if (sidebarApp.bookSpec && sidebarApp.bookSpec.contentWindow) {
         sidebarApp.bookSpec.contentWindow.focus();
      }
   }
}

DAISYOverlay.prototype.onOpenBookShelf = function() {
   var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
   var bookshelfWindow = ww.openWindow(null, "chrome://daisy/content/bookshelf.xul",'daisy-bookshelf',"chrome,resizable",{});
   bookshelfWindow.focus();
}

DAISYOverlay.initialize = function() {
   var catManager = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
   catManager.addCategoryEntry("ext-to-type-mapping","opf","application/oebps-package+xml",false,true);
   catManager.addCategoryEntry("ext-to-type-mapping","ncx","application/x-dtbncx+xml",false,true);
   catManager.addCategoryEntry("ext-to-type-mapping","dtb","application/x-dtbook+xml",false,true);

   DAISYOverlay.getInstance().service.updateFlashSecurity();
   // test of handler
   //catManager.addCategoryEntry("ext-to-type-mapping","atom","application/vnd.mozilla.maybe.feed",false,true);

}

